//==============================================================================
//
//  TOBESOFT Co., Ltd.
//  Copyright 2014 TOBESOFT Co., Ltd.
//  All Rights Reserved.
//
//  NOTICE: TOBESOFT permits you to use, modify, and distribute this file 
//          in accordance with the terms of the license agreement accompanying it.
//
//  Readme URL: http://www.nexacro.co.kr/legal/nexacro-public-license-readme-1.0.html	
//
//==============================================================================

if (!nexacro.Combo)
{
	// ==============================================================================
	// Combo Event Info
	// ==============================================================================
	nexacro.ComboCloseUpEventInfo = function (obj, id, beforeIndex, beforeText, beforeValue, afterIndex, afterText, afterValue, isSelect)
	{
		this.id = this.eventid = id || "oncloseup";
		this.fromobject = this.fromreferenceobject = obj;

		this.posttext = afterText;
		this.pretext = beforeText;
		this.postvalue = afterValue;
		this.prevalue = beforeValue;
		this.postindex = afterIndex;
		this.preindex = beforeIndex;
		this.isselect = isSelect;
	};
	var _pComboCloseUpEventInfo = nexacro._createPrototype(nexacro.Event, nexacro.ComboCloseUpEventInfo);
	nexacro.ComboCloseUpEventInfo.prototype = _pComboCloseUpEventInfo;
	_pComboCloseUpEventInfo._type_name = "ComboCloseUpEventInfo";

	delete _pComboCloseUpEventInfo;
	_pComboCloseUpEventInfo = null;

	// ==============================================================================
	// Combo Style
	// ==============================================================================
	nexacro.Combo_Style = function (target, id)
	{
		nexacro.Style.call(this, target, id);

		this.itemheight = null;
		this.itembackground = null;
		this.itemcolor = null;
		this.itemfont = null;
		this.itemgradation = null;
		this.itemborder = null;
		this.itembordertype = null;
		this.itempadding = null;
		this.buttonsize = null;
		this.itemaccessibility = null;
	};

	var _pComboStyle = nexacro._createPrototype(nexacro.Style, nexacro.Combo_Style);
	nexacro.Combo_Style.prototype = _pComboStyle;
	_pComboStyle._type_name = "ComboStyle";

	eval(nexacro._createValueAttributeEvalStr("_pComboStyle", "itemheight"));
	eval(nexacro._createBackgroundAttributeEvalStr("_pComboStyle", "itembackground"));
	eval(nexacro._createColorAttributeEvalStr("_pComboStyle", "itemcolor"));
	eval(nexacro._createFontAttributeEvalStr("_pComboStyle", "itemfont"));
	eval(nexacro._createGradationAttributeEvalStr("_pComboStyle", "itemgradation"));
	eval(nexacro._createBorderAttributeEvalStr("_pComboStyle", "itemborder"));
	eval(nexacro._createBordertypeAttributeEvalStr("_pComboStyle", "itembordertype"));
	eval(nexacro._createPaddingAttributeEvalStr("_pComboStyle", "itempadding"));
	eval(nexacro._createValueAttributeEvalStr("_pComboStyle", "buttonsize"));
	eval(nexacro._createAccessibilityAttributeEvalStr("_pComboStyle", "itemaccessibility"));

	_pComboStyle.__custom_emptyObject = function ()
	{
		this.itemheight = null;
		this.itembackground = null;
		this.itemcolor = null;
		this.itemfont = null;
		this.itemgradation = null;
		this.itemborder = null;
		this.itembordertype = null;
		this.itempadding = null;
		this.buttonsize = null;
		this.itemaccessibility = null;
	};

	_pComboStyle.__get_custom_style_value = function ()
	{
		var val = "";
		if (this.itemheight && this.itemheight._is_empty)
			val += "itemheight:" + this.itemheight._value + "; ";

		if (this.itembackground && this.itembackground._is_empty)
			val += "itembackground:" + this.itembackground._value + "; ";

		if (this.itemcolor && this.itemcolor.is_empty)
			val += "itemcolor:" + this.itemcolor._value + "; ";

		if (this.itemfont && this.itemfont._is_empty)
			val += "itemfont:" + this.itemfont._value + "; ";

		if (this.itemgradation && this.itemgradation._is_empty)
			val += "itemgradation:" + this.itemgradation._value + "; ";

		if (this.itemborder && this.itemborder._is_empty)
			val += "itemborder:" + this.itemborder._value + "; ";

		if (this.itembordertype && this.itembordertype._is_empty)
			val += "itembordertype:" + this.itembordertype._value + "; ";

		if (this.itempadding && this.itempadding._is_empty)
			val += "itempadding:" + this.itempadding._value + "; ";

		if (this.buttonsize && this.buttonsize._is_empty)
			val += "buttonsize:" + this.buttonsize._value + "; ";

		if (this.accessibility && this.accessibility._is_empty)
			val += "accessibility:" + this.accessibility._value + "; ";

		if (this.itemaccessibility && this.itemaccessibility._is_empty)
			val += "itemaccessibility:" + this.itemaccessibility._value + "; ";

		return val;
	};

	// ==============================================================================
	// Combo CurrentStyle
	// ==============================================================================
	nexacro.Combo_CurrentStyle = function ()
	{
		nexacro.CurrentStyle.call(this);

		this.itemheight = null;
		this.itembackground = null;
		this.itemcolor = null;
		this.itemfont = null;
		this.itemgradation = null;
		this.itemborder = null;
		this.itembordertype = null;
		this.itempadding = null;
		this.buttonsize = null;
		this.itemaccessibility = null;
	};

	var _pComboCurrentStyle = nexacro._createPrototype(nexacro.CurrentStyle, nexacro.Combo_CurrentStyle);
	nexacro.Combo_CurrentStyle.prototype = _pComboCurrentStyle;
	_pComboCurrentStyle._type_name = "ComboCurrentStyle";

	_pComboCurrentStyle.__custom_emptyObject = _pComboStyle.__custom_emptyObject;
	_pComboCurrentStyle.__get_custom_style_value = _pComboStyle.__get_custom_style_value;

	delete _pComboStyle;
	_pComboStyle = null;
	delete _pComboCurrentStyle;
	_pComboCurrentStyle = null;

	// ==============================================================================
	// nexacro.Combo
	// ==============================================================================
	nexacro.Combo = function (id, position, left, top, width, height, right, bottom, parent)
	{
		nexacro.Component.call(this, id, position, left, top, width, height, right, bottom, parent);

		this._selectinfo = {
			index: -1,
			text: "",
			value: undefined
		};

		this._eventinfo = {
			postindex: -1,
			posttext: "",
			postvalue: undefined,
			preindex: -1,
			pretext: "",
			prevalue: undefined,
			isselect: false
		};

		// SubControl
		this.comboedit = null;
		this.dropbutton = null;
		this.combolist = null;
		this.popupwindow = null;

		// Property		       
		this.value = undefined;
		this.index = -1;
		this.text = "";
		this.codecolumn = "";
		this.datacolumn = "";
		this.innerdataset = null;
		this.type = "dropdown";
		this.readonly = false;
		this.displayrowcount = -1;
		this.displaynulltext = "";
		this.autoselect = false;
		this.autoskip = false;
		this.imemode = "normal";
		this.inputtype = "normal";
		this.useime = "global";
		this.selectchangetype = "noboundup";
		this._exprcache = {};

		this._event_list = {
			"onclick": 1, "ondblclick": 1, "onkeypress": 1, "onkeydown": 1, "onkeyup": 1,
			"onkillfocus": 1, "onsetfocus": 1, "onmove": 1, "onsize": 1,
			"ondrag": 1, "ondragenter": 1, "ondragleave": 1, "ondragmove": 1, "ondrop": 1,
			"onlbuttondown": 1, "onlbuttonup": 1, "onmouseenter": 1, "onmouseleave": 1, "onmousemove": 1, "onrbuttondown": 1, "onrbuttonup": 1,
			"ontouchstart": 1, "ontouchmove": 1, "ontouchend": 1,
			"onflingstart": 1, "onfling": 1, "onflingend": 1,
			"onpinchstart": 1, "onpinch": 1, "onpinchend": 1,
			"onlongpress": 1, "onslidestart": 1, "onslide": 1, "onslideend": 1,
			"oneditclick": 1, "ontextchanged": 1, "onitemclick": 1, "canitemchange": 1, "onitemchanged": 1,
			"ondropdown": 1, "oncloseup": 1, "ontextchange": 1, "onchar": 1, "cancharchange": 1,
			"oncontextmenu": 1, "onmousewheel": 1
		};

		// internal variable 
		this._prevalue = undefined;
		this._preindex = -1;
		this._pretext = "";
		this._moverindex = -1;
		this._default_buttonsize = nexacro._getCachedStyleObj("buttonsize", "-1");
		this._innerdataset = null;
		this._filtereddataset = null;
		this._downkey = false;
		this._enterkey = false;
		this._keyval = undefined;
		this._text_change = false;
		this._want_arrows = true;
		this._accessibility_role = "combobox";
	};

	var _pCombo = nexacro._createPrototype(nexacro.Component, nexacro.Combo);
	nexacro.Combo.prototype = _pCombo;
	_pCombo._type_name = "Combo";

	// ==============================================================================
	// nexacro.Combo : Style
	// ============================================================================== 
	_pCombo.on_create_custom_style = function ()
	{
		return new nexacro.Combo_Style(this);
	};

	_pCombo.on_create_custom_currentStyle = function ()
	{
		return new nexacro.Combo_CurrentStyle();
	};

	_pCombo.on_apply_custom_pseudo = function (pseudo)
	{
		var curstyle = this.currentstyle;

		var style = this.on_find_CurrentStyle_itemheight(pseudo);
		if (style != curstyle.itemheight)
		{
			curstyle.itemheight = style;
			this.on_apply_style_itemheight(curstyle.itemheight);
		}

		style = this.on_find_CurrentStyle_border(pseudo);
		if (style != curstyle.border)
		{
			curstyle.border = style;
			this.on_apply_style_border(curstyle.border);
		}

		style = this.on_find_CurrentStyle_itembackground(pseudo);
		if (style != curstyle.itembackground)
		{
			curstyle.itembackground = style;
			this.on_apply_style_itembackground(curstyle.itembackground);
		}

		style = this.on_find_CurrentStyle_itemcolor(pseudo);
		if (style != curstyle.itemcolor)
		{
			curstyle.itemcolor = style;
			this.on_apply_style_itemcolor(curstyle.itemcolor);
		}

		style = this.on_find_CurrentStyle_itemfont(pseudo);
		if (style != curstyle.itemfont)
		{
			curstyle.itemfont = style;
			this.on_apply_style_itemfont(curstyle.itemfont);
		}

		style = this.on_find_CurrentStyle_itemgradation(pseudo);
		if (style != curstyle.itemgradation)
		{
			curstyle.itemgradation = style;
			this.on_apply_style_itemgradation(curstyle.itemgradation);
		}

		style = this.on_find_CurrentStyle_itemborder(pseudo);
		if (style != curstyle.itemborder)
		{
			curstyle.itemborder = style;
			this.on_apply_style_itemborder(curstyle.itemborder);
		}

		style = this.on_find_CurrentStyle_itembordertype(pseudo);
		if (style != curstyle.itembordertype)
		{
			curstyle.itembordertype = style;
			this.on_apply_style_itembordertype(curstyle.itembordertype);
		}

		style = this.on_find_CurrentStyle_itempadding(pseudo);
		if (style != curstyle.itempadding)
		{
			curstyle.itempadding = style;
			this.on_apply_style_itempadding(curstyle.itempadding);
		}

		style = this.on_find_CurrentStyle_itemaccessibility(pseudo);
		if (style != curstyle.itemaccessibility)
		{
			curstyle.itemaccessibility = style;
			this.on_apply_style_itemaccessibility(style);
		}

		style = this.on_find_CurrentStyle_buttonsize(pseudo);
		if (style != curstyle.buttonsize)
		{
			curstyle.buttonsize = style;
			this.on_apply_style_buttonsize(curstyle.buttonsize);
		}

		style = this.on_find_CurrentStyle_align(pseudo);
		if (style != curstyle.align)
		{
			curstyle.align = style;
			this.on_apply_style_align(curstyle.align);
		}

		style = this.on_find_CurrentStyle_font(pseudo);
		if (style != curstyle.font)
		{
			curstyle.font = style;
			this.on_apply_style_font(curstyle.font);
		}

		style = this.on_find_CurrentStyle_color(pseudo);
		if (style != curstyle.color)
		{
		    curstyle.color = style;

		    if (curstyle.color != null)
		        this.on_apply_style_color(curstyle.color);
		}
	    
	};

	_pCombo.on_find_CurrentStyle_itemheight = function (pseudo)
	{
		return this._find_pseudo_obj("itemheight", pseudo);
	};

	_pCombo.on_find_CurrentStyle_itembackground = function (pseudo)
	{
		return this._find_pseudo_obj("itembackground", pseudo, "background");
	};

	_pCombo.on_find_CurrentStyle_itemcolor = function (pseudo)
	{
	    return this._find_pseudo_obj("itemcolor", pseudo, "color") || nexacro.Component._default_color; 
	};

	_pCombo.on_find_CurrentStyle_itemfont = function (pseudo)
	{
		return this._find_pseudo_obj("itemfont", pseudo, "font");
	};

	_pCombo.on_find_CurrentStyle_itemgradation = function (pseudo)
	{
		return this._find_pseudo_obj("itemgradation", pseudo, "gradation");
	};
	_pCombo.on_find_CurrentStyle_itemborder = function (pseudo)
	{
		return this._find_pseudo_obj("itemborder", pseudo, "border");
	};

	_pCombo.on_find_CurrentStyle_itembordertype = function (pseudo)
	{
		return this._find_pseudo_obj("itembordertype", pseudo, "bordertype");
	};

	_pCombo.on_find_CurrentStyle_itempadding = function (pseudo)
	{
		return this._find_pseudo_obj("itempadding", pseudo, "padding") || nexacro.Component._default_padding;
	};

	_pCombo.on_find_CurrentStyle_itemaccessibility = function (pseudo)
	{
		return this._find_pseudo_obj("itemaccessibility", pseudo, "accessibility") || nexacro.Component._default_accessibility;
	};

	_pCombo.on_find_CurrentStyle_buttonsize = function (pseudo)
	{
		return this._find_pseudo_obj("buttonsize", pseudo) || this._default_buttonsize;
	};
    
	_pCombo.on_find_CurrentStyle_align = function (pseudo, childctrl)
	{	    
	    if (childctrl)
	    {
	        return childctrl._find_pseudo_obj("align", pseudo, "align") || this._find_pseudo_obj("align", pseudo, "align");
	    }
	    return this._find_pseudo_obj("align", pseudo, "align");
	};

	_pCombo.on_find_CurrentStyle_background = function (pseudo, childctrl)
	{
	    if (childctrl)
	    {
	        return childctrl._find_pseudo_obj("background", pseudo, "background") || this._find_pseudo_obj("background", pseudo, "background");
	    }
	    return this._find_pseudo_obj("background", pseudo, "background");
	};

	_pCombo.on_find_CurrentStyle_border = function (pseudo, childctrl)
	{
	    if (childctrl)
	    {
	        return childctrl._find_pseudo_obj("border", pseudo, "border") || this._find_pseudo_obj("border", pseudo, "border");
	    }
	    return this._find_pseudo_obj("border", pseudo, "border");
	};

	_pCombo.on_find_CurrentStyle_bodertype = function (pseudo, childctrl)
	{
	    if (childctrl)
	    {
	        return childctrl._find_pseudo_obj("bodertype", pseudo, "bodertype") || this._find_pseudo_obj("bodertype", pseudo, "bodertype");
	    }
	    return this._find_pseudo_obj("bodertype", pseudo, "bodertype");
	};

	_pCombo.on_find_CurrentStyle_color = function (pseudo, childctrl)
	{
	    if (childctrl)
	    {
	        return childctrl._find_pseudo_obj("color", pseudo, "color") || this._find_pseudo_obj("color", pseudo, "color");
	    }
	    return this._find_pseudo_obj("color", pseudo, "color");
	};

	_pCombo.on_find_CurrentStyle_font = function (pseudo, childctrl)
	{
	    if (childctrl)
	    {
	        return childctrl._find_pseudo_obj("font", pseudo, "font") || this._find_pseudo_obj("font", pseudo, "font");
	    }
	    return this._find_pseudo_obj("font", pseudo, "font");
	};

	_pCombo.on_find_CurrentStyle_gradation = function (pseudo, childctrl)
	{
	    if (childctrl)
	    {
	        return childctrl._find_pseudo_obj("gradation", pseudo, "gradation") || this._find_pseudo_obj("gradation", pseudo, "gradation");
	    }
	    return this._find_pseudo_obj("gradation", pseudo, "gradation");
	};
	
	_pCombo.on_find_CurrentStyle_accessibility = function (pseudo, childctrl)
	{
	    if (childctrl)
	    {
	        return childctrl._find_pseudo_obj("accessibility", pseudo, "accessibility") || this._find_pseudo_obj("accessibility", pseudo, "accessibility");
	    }
	    return this._find_pseudo_obj("accessibility", pseudo, "accessibility") || nexacro.Component._default_accessibility;
	};

	_pCombo.on_update_style_itemheight = function ()
	{
		this.on_apply_style_itemheight(this.currentstyle.itemheight = this.on_find_CurrentStyle_itemheight(this._pseudo));
	};

	_pCombo.on_update_style_itembackground = function ()
	{
		this.on_apply_style_itembackground(this.currentstyle.itembackground = this.on_find_CurrentStyle_itembackground(this._pseudo));
	};

	_pCombo.on_update_style_itemcolor = function ()
	{
		this.on_apply_style_itemcolor(this.currentstyle.itemcolor = this.on_find_CurrentStyle_itemcolor(this._pseudo));
	};

	_pCombo.on_update_style_itemfont = function ()
	{
		this.on_apply_style_itemfont(this.currentstyle.itemfont = this.on_find_CurrentStyle_itemfont(this._pseudo));
	};

	_pCombo.on_update_style_itemgradation = function ()
	{
		this.on_apply_style_itemgradation(this.currentstyle.itemgradation = this.on_find_CurrentStyle_itemgradation(this._pseudo));
	};

	_pCombo.on_update_style_itemborder = function ()
	{
		this.on_apply_style_itemborder(this.currentstyle.itemborder = this.on_find_CurrentStyle_itemborder(this._pseudo));
	};

	_pCombo.on_update_style_itembordertype = function ()
	{
		this.on_apply_style_itembordertype(this.currentstyle.itembordertype = this.on_find_CurrentStyle_itembordertype(this._pseudo));
	};

	_pCombo.on_update_style_itempadding = function ()
	{
		this.on_apply_style_itempadding(this.currentstyle.itempadding = this.on_find_CurrentStyle_itempadding(this._pseudo));
	};

	_pCombo.on_update_style_itemaccessibility = function ()
	{
		this.on_apply_style_itemaccessibility(this.currentstyle.itemaccessibility = this.on_find_CurrentStyle_itemaccessibility(this._pseudo));
	};

	_pCombo.on_update_style_buttonsize = function ()
	{
		this.on_apply_style_buttonsize(this.currentstyle.buttonsize = this.on_find_CurrentStyle_buttonsize(this._pseudo));
	};

	_pCombo.on_apply_style_color = function (color)
	{
		if (this.comboedit)
		{
			this.comboedit.on_apply_style_color(color);
		}
	};

	_pCombo.on_apply_style_font = function (font)
	{
		if (this.comboedit)
		{
			this.comboedit.on_apply_style_font(font);
		}
	};

	_pCombo.on_apply_style_align = function (align)
	{
		if (!align)
		{
			align = this.on_find_CurrentStyle_align(this._pseudo);
		}
		if (this.comboedit)
		{
			this.comboedit.style.set_align(align);
		}
	};

	_pCombo.on_apply_style_cursor = function (cursor)
	{
		nexacro.Component.prototype.on_apply_style_cursor.call(this, cursor);

		if (this.comboedit)
		{
			this.comboedit.on_apply_style_cursor(cursor);
		}
		if (this.dropbutton)
		{
			this.dropbutton.on_apply_style_cursor(cursor);
		}

	};

	_pCombo.on_apply_style_itemheight = function (v)
	{
		var combolist = this.combolist;
		if (!combolist) return false;
		combolist.on_apply_style_itemheight(v);
	};

	_pCombo.on_apply_style_itembackground = function (v)
	{
		var combolist = this.combolist;
		if (!combolist) return false;
		combolist.on_apply_style_itembackground(v);
	};

	_pCombo.on_apply_style_itemcolor = function (v)
	{
		var combolist = this.combolist;
		if (!combolist) return false;
		combolist.on_apply_style_color(v);
	};

	_pCombo.on_apply_style_itemfont = function (v)
	{
		var combolist = this.combolist;
		if (!combolist) return false;
		combolist.on_apply_style_font(v);
	};

	_pCombo.on_apply_style_itemgradation = function (v)
	{
		var combolist = this.combolist;
		if (!combolist) return false;
		combolist.on_apply_style_itemgradation(v);
	};

	_pCombo.on_apply_style_itemborder = function (v)
	{
		var combolist = this.combolist;
		if (!combolist) return false;
		combolist.on_apply_style_itemborder(v);
	};

	_pCombo.on_apply_style_itembordertype = function (v)
	{
		var combolist = this.combolist;
		if (!combolist) return false;
		combolist.on_apply_style_itembordertype(v);
	};

	_pCombo.on_apply_style_itempadding = function (v)
	{
		var combolist = this.combolist;
		if (!combolist) return false;
		combolist.on_apply_style_itempadding(v);
	};

	_pCombo.on_apply_style_itemaccessibility = function (v)
	{
		var combolist = this.combolist;
		if (!combolist) return false;
		combolist.on_apply_style_itemaccessibility(v);
	};

	_pCombo.on_apply_style_buttonsize = function (v)
	{
	    this._recalcLayout();
	};

	_pCombo.on_apply_style_accessibility = function (accessibility)
	{
	    nexacro.Component.prototype.on_apply_style_accessibility.call(this, accessibility);
	    if (this.comboedit)
	        this.comboedit.on_apply_style_accessibility(accessibility);
	};

	// ==============================================================================
	// nexacro.Combo : Create & Destroy & Update
	// ==============================================================================   
	_pCombo.on_create_contents = function ()
	{
		var control_elem = this.getElement();
		if (control_elem)
		{
			this.comboedit = new nexacro.ComboEditCtrl("comboedit", "absolute", 0, 0, 0, 0, null, null, this);
			this.dropbutton = new nexacro.ComboButtonCtrl("dropbutton", "absolute", 0, 0, 0, 0, null, null, this);

			this.comboedit.createComponent();
			this.dropbutton.createComponent();
		}
	};

	_pCombo.on_created_contents = function ()
	{
		this.on_apply_autoskip();
		this.on_apply_displaynulltext();
		this.on_apply_imemode();
		this.on_apply_type();
		this.on_apply_autoselect();

		if (this.value !== undefined)
		{
			this.on_apply_value();
		}
		else if (this.index > -1)
		{
			this.on_apply_index();
		}
		else if (this.text !== "")
		{
			this.on_apply_text();
		}

		this._setEventHandler("onmousewheel", this.on_notify_combo_mousewheel, this);

		this.comboedit._setEventHandler("oneditclick", this.on_notify_edit_oneditclick, this);
		this.comboedit._setEventHandler("ontextchanged", this.on_notify_edit_ontextchanged, this);
		this.comboedit._setEventHandler("ontextchange", this.on_notify_edit_ontextchange, this);
		this.comboedit._setEventHandler("onchar", this.on_notify_edit_onchar, this);
		this.comboedit._setEventHandler("cancharchange", this.on_notify_edit_cancharchange, this);
		this.comboedit._setEventHandler("ontap", this.on_notify_ondropdown, this);
		if (!(nexacro.isTouchInteraction && nexacro.SupportTouch))
		{
		    this.comboedit._setEventHandler("onlbuttondown", this.on_notify_edit_onlbuttondown, this);
		    this.dropbutton._setEventHandler("onlbuttondown", this.on_notify_ondropdown, this);
		}

		this.dropbutton._setEventHandler("ontap", this.on_notify_ondropdown, this);

		this.comboedit.on_created();
		this.dropbutton.on_created();

		if (nexacro._enableaccessibility)
		{
		    this._want_arrows = false;
			this._setAccessibilityActiveDescendant(this.comboedit);
		    this._setAccessibilityStatAutoComplete("list");

			this.on_apply_style_itemaccessibility(this.currentstyle.itemaccessibility = this.on_find_CurrentStyle_itemaccessibility(this._pseudo));
		}

        this.on_apply_style_align(this.currentstyle.align);
		this.on_apply_style_cursor(this.currentstyle.cursor);

        if (!this.innerdataset)
        {            
            this.set_text("");            
        }

	};

	_pCombo.on_destroy_contents = function ()
	{
	    var form = this._getRootForm();
	    if (form)
	        form._bind_manager._dettachSBindItem(this);

		if (this.comboedit)
		{
			this.comboedit.destroy();
			this.comboedit = null;
		}
		if (this.dropbutton)
		{
			this.dropbutton.destroy();
			this.dropbutton = null;
		}
		if (this.combolist)
		{
			this.combolist.destroy();
			this.combolist = null;
		}
		if (this.popupwindow)
		{
			this.popupwindow.destroy();
			this.popupwindow = null;
		}

		if (this._innerdataset)
		{
			this._innerdataset._removeEventHandler("onvaluechanged", this._callback_onvaluechanged, this);
			this._innerdataset._removeEventHandler("onrowsetchanged", this._callback_onrowsetchanged, this);
		}
		this._innerdataset = null;
		this.innerdataset = null;
		this._filtereddataset = null;
		this._selectinfo = null;
		this._eventinfo = null;
		this._exprcache = null;
		this._default_buttonsize = null;
	};

	_pCombo.on_change_containerRect = function (container_width, container_height)
	{
	    if (this._isPopupVisible())
	        this._closePopup();

		this._recalcLayout();
	};

	// ==============================================================================
	// nexacro.Combo : Override 
	// ==============================================================================  
	_pCombo.on_apply_custom_setfocus = function (evt_name)
	{
	    var comboedit = this.comboedit;

		try
		{
		    comboedit._stat_change("focus", "focused");
		    if (!(nexacro.isTouchInteraction && nexacro.SupportTouch))
		    {
		    comboedit.on_apply_custom_setfocus(evt_name);
		    }
		    else
		    {
		        nexacro.Component.prototype.on_apply_custom_setfocus.call(this, evt_name);
		    }
		}
		catch (e)
		{

		}
	};

	_pCombo.on_getBindableProperties = function ()
	{
		return "value";
	};

	_pCombo._is_recheck = false;
	_pCombo._callback_onvaluechanged = function (obj, e)
	{
	    if (this.type == "filter")
	    {
	        this._createFilteredDataset();
	    }
			this._recheckValue();
			this._is_recheck = true;
	};

	_pCombo._callback_onrowsetchanged = function (obj, e)
	{
	    if (e.reason == 31) // 31 -> filter
	    {
	        if (this.type == "filter")
	        {
	            this._createFilteredDataset();
	        }
	    }
	    else if(e.reason == 10)
	    {
	        this.set_index(-1);
	    }
		if (this._is_recheck == false)
		{
			this._recheckValue();
			this._is_recheck = true;
		}
	};

	_pCombo.on_apply_prop_enable = function (v)
	{
		nexacro.Component.prototype.on_apply_prop_enable.call(this, v);

		var enable = v;
		if (v == undefined) enable = this.enable;

		if (this.comboedit)
		{
			this.comboedit._setEnable(enable);
		}
		if (this.dropbutton)
		{
			this.dropbutton._setEnable(enable);
		}
		if (this.combolist)
		{
			this.combolist._setEnable(enable);
		}

	};

	_pCombo.on_apply_custom_class = function ()
	{
	    if (this.comboedit)
	    {
	        this.comboedit.on_apply_prop_class();
	    }
	    if (this.dropbutton)
	    {
	        this.dropbutton.on_apply_prop_class();
	    }
	    if (this.combolist)
	    {
	        this.combolist.on_apply_prop_class();
	    }
	};

    _pCombo.on_init_bindSource = function (columnid, propid, ds)
    {
		if (this.type == "filter")
		{
			this._createFilteredDataset();
		}

        this._prevalue = undefined;
		this._preindex = -1;
		this._pretext = "";
		this.value = undefined;

		this.index = -1;
		this.text = "";

	    this._eventinfo.preindex = -1;
	    this._eventinfo.pretext = "";
	    this._eventinfo.prevalue = undefined;
	    this._eventinfo.postindex = -1;
	    this._eventinfo.posttext = "";
	    this._eventinfo.postvalue = undefined;

		this.redraw();
		return true;
    };

	_pCombo.on_change_bindSource = function (propid, pSendDataset, rowIdx, colIdx, colArrayIdx)
	{
		if (propid !== "value" || !pSendDataset || rowIdx < -1 || colIdx < -1)
		{
			return false;
		}

		if (this.type == "filter")
		{
			this._createFilteredDataset();
		}

		var value = pSendDataset.getColumn(rowIdx, colIdx);

		if (this.value == value)
		{
			return true;
		}

		this._prevalue = this.value;
		this._preindex = this.index;
		this._pretext = this.text;
		this.value = value;
		

		this.index = this._getIndex(value);
		this.text = this._getItemText(this.index);
                
	    if (this.index == -1 && !this._innerdataset)		
		{
		    this.index = rowIdx;
		    this.text = value;
		}

	    this._eventinfo.preindex = this._preindex;
	    this._eventinfo.pretext = this._pretext;
	    this._eventinfo.prevalue = this._prevalue;
	    this._eventinfo.postindex = this.index;
	    this._eventinfo.posttext = this.text;
	    this._eventinfo.postvalue = this.value;

		this.redraw();
		return true;
	};

	_pCombo.on_update_position = function (resize_flag, move_flag)
	{
	    nexacro.Component.prototype.on_update_position.call(this, resize_flag, move_flag);
	    // popupwindow가 열려 있는 상태에서 cell 이동시 popupwindow position 조정
	    if (this._isPopupVisible())
	    {
	        if (resize_flag || move_flag)
	        {
	            this._closePopup();
	            return;
	        }

	        this._update_popupwindow_position();
	    }
	};

	_pCombo._getDlgCode = function (keycode, altKey, ctrlKey, shiftKey)
	{
		
		if (keycode == nexacro.Event.KEY_UP || keycode == nexacro.Event.KEY_DOWN)
		{
			if (ctrlKey || altKey)
			{
				return { want_tab: false, want_return: false, want_escape: false, want_chars: false, want_arrows: true };
			}
		}
	    return { want_tab: false, want_return: false, want_escape: false, want_chars: false, want_arrows: this._want_arrows };
	};


	_pCombo.on_get_style_accessibility_label = function ()
	{
		return "";//this.value;
	};

	_pCombo._getAccessibilityReadLabel = function (bwholeread)
	{
	    var _readlabel = nexacro.Component.prototype._getAccessibilityReadLabel.call(this);
	    if (bwholeread)
	    {
	        if (this.comboedit._input_element._wantAccessibilityAdditionalLabel)
	        {
	            if (this.comboedit._input_element._wantAccessibilityAdditionalLabel())
	            {
	                _readlabel += " " + this.text;
	            }
	        }
	    }
	    return _readlabel;
	};

	// ==============================================================================
	// nexacro.Combo : Properties
	// ==============================================================================
	_pCombo.set_visible = function (v)
	{
		if (v === undefined || v === null) return;
		v = nexacro._toBoolean(v);

		if (this.visible != v)
		{
			nexacro.Component.prototype.set_visible.call(this, v);
			if (!v && this._is_created) this.closeDropdown();
		}
	};

	_pCombo.set_value = function (v)
	{
        if (v !== this.value)
		{
			var ret = this.applyto_bindSource("value", v);
			if (ret == false)
			{
				return;
			}
			this._prevalue = this.value;
			this.value = v;
			this.on_apply_value();
		}
		return v;
	};

	_pCombo.on_apply_value = function ()
	{
		var control_elem = this.getElement();
		if (!control_elem) return;

		var fds = this._filtereddataset ? this._filtereddataset : this._getFilteredDataset();
		var ds = this.type == "filter" ? fds : this._innerdataset;

		if (ds)
		{
			var row_count = ds.getRowCount();
			for (var i = 0; i < row_count; i++)
			{
				var item_value = this._getItemValue(i);

                if (item_value instanceof nexacro.Decimal && this.value instanceof nexacro.Decimal)
				{
					if (item_value.isEqual(this.value))
					{
					this.index = i;
					this.text = this._getItemText(this.index);
					this._preindex = this.index;
					this._prevalue = this.value;

					this.redraw();
					return;
				}
			}
				else if (this.value == item_value)
				{
					this.index = i;
					this.text = this._getItemText(this.index);
					this._preindex = this.index;
					this._prevalue = this.value;

					this.redraw();
					return;
				}
			}

            // dataset에 value가 없는경우에도 value에는 설정이 되어야합니다. spec 변경
				this.index = -1;
				this.text = "";				
			}
		this._preindex = this.index;
		this._prevalue = this.value;
		this.redraw();
	};

	_pCombo.set_index = function (v)
	{
		if (v != this.index)
		{
			var curidx = this._moverindex;
			var codecol = this.codecolumn;
			var datacol = this.datacolumn;
			var val, ds;

			if (this.type == "filter")
			{
				ds = this._filtereddataset;
			}
			else
			{
				ds = this._innerdataset;
			}

			if (!ds)
				return;

			v = parseInt(v, 10) | 0;

			this._preindex = this.index;
			this._pretext = this.text;
			this._prevalue = this.value;
			this.index = v;
			this.on_apply_index();
		}
		return v;
	};

	_pCombo.on_apply_index = function ()
	{
		var control_elem = this.getElement();
		if (!control_elem) return;

		var ds = this._innerdataset;
		var index = this.index;        

		if (index >= 0 && ds && index < ds.getRowCount())
		{
			this.value = this._getItemValue(index);
			this.text = this._getItemText(index);
			
            			
			if (this.applyto_bindSource("value", this.value) === false && !nexacro._isNull(this.value))
			{
			    this.index = this._preindex;
			    this.value = this._prevalue;
			    this.text = this._getItemText(this.index);
			}
			
			this.redraw();
			this.comboedit.setCaretPos(0);
			return;
		}

		this.index = -1;
		this.value = undefined;
		this.text = "";

		if (ds)
		{
			if (this.applyto_bindSource("value", this.value) === false)
			{
				this.index = this._preindex;
				this.value = this._prevalue;
				if (this.index != -1)
				{
					this.text = this._getItemText(this.index);
				}
			}
		}
		this._preindex = this.index;
		this._prevalue = this.value;
		this.redraw();
		this.comboedit.setCaretPos(0);
	};


	_pCombo.set_text = function (v)
	{
		if (this.text != v)
		{
			this._pretext = this.text;
			this.text = v == undefined ? "" : v;
			this.on_apply_text();
		}
		return v;
	};

	_pCombo.on_apply_text = function ()
	{
		var control_elem = this.getElement();
		if (!control_elem) return;

		var fds = this._filtereddataset ? this._filtereddataset : this._getFilteredDataset();
		var ds = this.type == "filter" ? fds : this._innerdataset;
		var combo_list = this.combolist;
		var combo_edit = this.comboedit;
		var datacol = this.datacolumn;
		var codecol = this.codecolumn;

		if (!ds || (!datacol && !codecol))
		{
			if (combo_edit._input_element._value == undefined || this._pretext != "")
			{
			    if (this.value)
			    {
			        this._setEditValue(this.text);
			    }
			    else
			    {
			        if (this.displaynulltext || this.text == "")
                    {
			            this._setEditValue(undefined);
			        }
			        else
			        {
                        this._setEditValue(this.text);
			        }
			    }
			}
			return;
		}


		if (ds)
		{
			var row_count = ds.getRowCount();
			for (var i = 0; i < row_count; i++)
			{
			    if (this.text == this._getItemText(i))
			    {
			        this.index = i;
			        this.value = this._getItemValue(i);

			        if (this.applyto_bindSource("value", this.value) === false)
			        {
			            this.index = this._preindex;
			            this.value = this._prevalue;
			        }

			        this._preindex = this.index;
			        this._prevalue = this.value;

			        this.redraw();
			        return;
			    }
			}
				this.value = undefined;
				this.text = "";
			}
		this._preindex = this.index;
		this._prevalue = this.value;
		this.redraw();
	};

	_pCombo.set_codecolumn = function (v)
	{
		if (v != this.codecolumn)
		{
			this.codecolumn = v;
			this.on_apply_codecolumn();
		}
		return v;
	};

	_pCombo.on_apply_codecolumn = function ()
	{
		if (this.combolist)
		{
			this.combolist.set_codecolumn(this.codecolumn);
		}
		this._recheckValue();
		this._is_recheck = true;
	};

	_pCombo.set_datacolumn = function (v)
	{
		if (v != this.datacolumn)
		{
			this.datacolumn = v;
			this.on_apply_datacolumn();
		}
		return v;
	};

	_pCombo.on_apply_datacolumn = function ()
	{
		if (this.combolist)
		{
			this.combolist.set_datacolumn(this.datacolumn);
		}
		this._recheckValue();
		this._is_recheck = true;
	};

	_pCombo.setInnerDataset = function (obj)
    {
        if (!obj)
        {
            this._innerdataset = null;
            this.innerdataset = "";
            this.on_apply_innerdataset();
        }
        else if (obj instanceof nexacro.Dataset || (typeof obj == "object" && obj._type_name == "Dataset"))
        {
            if (this.innerdataset != obj.id)
            {
                this._innerdataset = obj;
                this.innerdataset = obj.id;
                this.on_apply_innerdataset();
                // RP_39099)바인딩된 데이타셋이 바뀌면 기존 comboedit에 값을 재설정하는 부분이 없음.
                this._recheckValue();
                this._is_recheck = true;
            }
        }
    };

	_pCombo.getInnerDataset = function ()
	{
	    return this._innerdataset;
	};

	_pCombo.set_innerdataset = function (str)
	{
	    if (typeof str != "string")
	    {
	        this.setInnerDataset(str);
	        return;
			}
	    if (str != this.innerdataset)
	    {
	        if (!str)
	        {
	            this._innerdataset = null;
	            this.innerdataset = "";
		}
		else
			{
	            str = str.replace("@", "");
	            this._innerdataset = this._findDataset(str);
	            this.innerdataset = str;
	        }
				this.on_apply_innerdataset();
			}
	    else if (this.innerdataset && !this._innerdataset)
	    {
	        this._setInnerDatasetStr(this.innerdataset);
	        this.on_apply_innerdataset();
		}
	    return this.innerdataset;
	};

	_pCombo.on_apply_innerdataset = function ()
	{
		var ds = this._innerdataset;
		if (this.combolist)
		{
			this.combolist.setInnerDataset(ds);
		}

		if (ds)
		{
			ds._setEventHandler("onvaluechanged", this._callback_onvaluechanged, this);
			ds._setEventHandler("onrowsetchanged", this._callback_onrowsetchanged, this);

			if (this.type == "filter")
			{
				this._createFilteredDataset();
			}
		}
	};

	_pCombo.set_displayrowcount = function (v)
	{
		if (v != this.displayrowcount)
		{
			this.displayrowcount = v;
		}
		return v;
	};


	_pCombo.set_autoselect = function (v)
	{
		v = nexacro._toBoolean(v);
		if (v != this.autoselect)
		{
			this.autoselect = v;
			this.on_apply_autoselect();
		}
		return v;
	};

	_pCombo.on_apply_autoselect = function ()
	{
	    if (this.type == "search")
	    {
	        this.comboedit && this.comboedit.set_autoselect(this.autoselect);
	    }
	    else
	    {
	        this.comboedit && this.comboedit.set_autoselect(false);
	    }
	};

	_pCombo.set_autoskip = function (v)
	{
		if (v != this.autoskip)
		{
			this.autoskip = v;
			this.on_apply_autoskip();
		}
		return v;
	};

	_pCombo.on_apply_autoskip = function ()
	{
		this.comboedit && this.comboedit.set_autoskip(this.autoskip);
	};

	_pCombo.set_displaynulltext = function (v)
	{
		if (v != this.displaynulltext)
		{
			this.displaynulltext = v;
			this.on_apply_displaynulltext();
		}
		return v;
	};

	_pCombo.on_apply_displaynulltext = function ()
	{
		this.comboedit && this.comboedit.set_displaynulltext(this.displaynulltext);
	};

	_pCombo.set_type = function (v)
	{
		if (v != this.type)
		{
			this.type = v;
			this.on_apply_type();
		}
		return v;
	};

	_pCombo.on_apply_type = function ()
	{
		var control_elem = this.getElement();
		if (!control_elem) return;

		if (this._filtereddataset)
		    this._filtereddataset.filter("");

		if (this.type == "dropdown")
		{
			this.comboedit.set_readonly(true);
		}
		else
		{
		    this.comboedit.set_readonly(this.readonly);
		}

		    this.on_apply_autoselect();
	};

	_pCombo.set_imemode = function (v)
	{
		this.imemode = nexacro._toString(v);
		this.on_apply_imemode();
	};

	_pCombo.on_apply_imemode = function ()
	{
		this.comboedit && this.comboedit.set_imemode(this.imemode);
	};

	_pCombo.set_inputtype = function (v)
	{

	};

	_pCombo.set_comboedit = function (v)
	{

	};

	_pCombo.set_combolist = function (v)
	{

	};

	_pCombo.set_popupwindow = function (v)
	{

	};

	_pCombo.set_readonly = function (v)
	{
		v = nexacro._toBoolean(v);

		if (v != this.readonly)
		{
			this.readonly = v;
		    this.on_apply_readonly();
		}
	};

    _pCombo.on_apply_readonly = function ()
			{
        var v = this.readonly;
        var comboedit = this.comboedit;

        if (v)
        {
            this._stat_change("readonly", this._pseudo);
        }
        else
        {
            this._stat_change("writable", this._pseudo == "readonly" ? "normal" : this._pseudo);
        }

        if (comboedit)
		{
				if (this.type == "dropdown")
            {
                comboedit.set_readonly(true);
            }
				else
            {
                comboedit.set_readonly(v);
			}
		}
	};

	_pCombo.set_useime = function (v)
	{

	};

	_pCombo.set_selectchangetype = function (v)
	{
		this.selectchangetype = nexacro._toString(v);
	};

	// ==============================================================================
	// nexacro.Combo : Methods
	// ==============================================================================
	_pCombo.redraw = function ()
	{
		var combo_edit = this.comboedit;
		var combo_list = this.combolist;

		if (combo_edit)
		{
            if (this.text)
		    {
		        this._setEditValue(this.text);
		    }
		    else
		    {
		        this._setEditValue(undefined);
		    }
		}
		
		if (combo_list)
		{
		    var idx = this._getRawToListindex(this.index);
		    combo_list._overeditemindex = idx;
		    combo_list.set_index(idx);
		}
		this._moverindex = this.index;
	};

	_pCombo.dropdown = function ()
	{
		if (this.enable === false || this.readonly === true || this.visible === false) return;

		if (!this.isDropdown())
		{
			var fds = this._filtereddataset ? this._filtereddataset : this._getFilteredDataset();
			var ds = this.type == "filter" ? fds : this._innerdataset;
            if (ds && ds.rowcount == 0)
                ds = this._innerdataset;
			
			this._showPopup(ds, this.index);
		}
	};

	_pCombo.isDropdown = function ()
	{
		if (!this.popupwindow) return false;
		var rtn = this.popupwindow._is_popup();
		return rtn;
	};

	_pCombo.getSelect = function ()
	{
		if (this._control_element)
		{
			return this.comboedit.getSelect();
		}
	};

	_pCombo.getCount = function ()
	{
		if (this._control_element)
		{
			if (this.combolist)
				return this.combolist.getCount();
			else if (this._innerdataset)
				return this._innerdataset.getRowCount();
			else
				return 0;
		}
	};

	_pCombo.getSelectedText = function ()
	{
		if (this._control_element)
		{
			return this.comboedit.getSelectedText();
		}
	};

	_pCombo.getCaretPos = function ()
	{
		if (this.readonly) return -1;

		if (this._control_element)
		{
			return this.comboedit.getCaretPos();
		}
	};

	_pCombo.setSelect = function (start, end)
	{
		if (this._control_element)
		{
			return this.comboedit.setSelect(start, end);
		}
	};

	_pCombo.setSelectedText = function (v)
	{
		if (this._control_element)
		{
			return this.comboedit.setSelectedText(v);
		}
	};

	_pCombo.closeDropdown = function (obj, e)
	{
		if (this.isDropdown())
		{
			this.popupwindow._closePopup();
		}
	};

	_pCombo.updateToDataset = function ()
	{
		return this.applyto_bindSource("value", this.value);
	};

	_pCombo.isAboveSelected = function ()
	{
	};

	// ==============================================================================
	// nexacro.Combo : Event Handlers
	// ==============================================================================
	_pCombo.on_notify_ondropdown = function (obj, e)
	{
	    if (this.readonly) return false;

	    var popup_window = this.popupwindow;
	    var combo_list = this.combolist;
	    var ds = this._innerdataset;

	    if (!ds) return false;

	    if (this._isPopupVisible() == true)
	    {
	        popup_window._closePopup();
	    }
	    else
	    {
	        if (combo_list && this.type == "filter")
	        {
	            var items = ds.getRowCount();
	            for (i = 0; i < items; i++)
	            {
	                if (this.text == this._getItemText(i))
	                {
	                    this._showPopup(ds, i);
	                    return false;
	                }
	                else
	                {
	                    this._showPopup(ds, this.index);
	                }
	            }
	        }
	        else
	        {
	            this._showPopup(ds, this.index);
	        }
	    }
	    return false;
	};
	

	_pCombo.on_notify_item_onlbuttonup = function ()
	{
		if (!this.combolist)
		{
			return false;
		}

		if (this.selectchangetype != "noboundup")
		{
			return false;
		}

		if (this._isPopupVisible())
		{
			this.popupwindow._closePopup();
		}

		return false;
	};
	_pCombo.on_notify_item_canitemchange = function (obj, e)
	{
	    var eventinfo = e, retv;
	    if (this.type == "filter")
	    {
	        var fds = this._filtereddataset ? this._filtereddataset : this._getFilteredDataset();
	        var raw_post_index = this._getRawIndex(fds, e.postindex);
	        raw_post_index = (raw_post_index == -1) ? e.postindex : raw_post_index;
	    }
	    else
	    {
	        raw_post_index = e.postindex;
	    }

	    if (retv = this.on_fire_canitemchange(obj, this.index, this.text, this.value, raw_post_index, e.posttext, e.postvalue))
	    {
	        eventinfo.preindex = eventinfo.postindex;
	        eventinfo.pretext = eventinfo.posttext;
	        eventinfo.prevalue = eventinfo.postvalue;

	        eventinfo.postindex = raw_post_index;
	        eventinfo.posttext = e.posttext;
	        eventinfo.postvalue = e.postvalue;

	        this._setIndex(raw_post_index);

	        if (this._isPopupVisible())
	        {
	            this.popupwindow._closePopup();
	        }
	    }
	    else
	    {
	        if (this._isPopupVisible())
	        {
	            this.popupwindow._closePopup();
	        }
	        fds.set_filterstr("");
	    }

	    if (this.comboedit)
	        this.comboedit._setFocus(false);

	    return retv;
	};

	_pCombo.on_notify_item_onitemclick = function (obj, e)
	{
		if (!this.combolist || !this.comboedit) return false;

		this.on_fire_onitemclick(obj, e.index, e.itemtext, e.itemvalue, e.button, e.altKey, e.ctrlKey, e.shiftKey, e.screenX, e.screenY, e.canvasX, e.canvasY, e.clientX, e.clientY);

        // 동일한 index를 선택하더라도 canitemchange가 발생되어야 한다.
		if (e.index == this.index)
		{
		    if (this.type == "filter")
		    {
		        var fds = this._filtereddataset ? this._filtereddataset : this._getFilteredDataset();
		        var ds = this.type == "filter" ? fds : this._innerdataset;
		        var curidx = this._getRawIndex(ds, e.index);
		        
		        if (curidx != this.index)
		            return;
		    }

		    var eventinfo = e, retv;
		    retv = this.on_fire_canitemchange(obj, this.index, this.text, this.value, e.index, e.itemtext, e.itemvalue);
		
		    if (this._isPopupVisible())
		    {
		        this.popupwindow._closePopup();
		    }
		}
	};

	_pCombo.on_notify_item_onitemchanged = function (obj, e)
	{
		if (!this.combolist || !this.comboedit) return false;

		var retv = false;
		var popup_window = this.popupwindow;
		var combo_list = this.combolist;
		var combo_edit = this.comboedit;
		var curidx = e.postindex;
		var codecol = this.codecolumn;
		var datacol = this.datacolumn;
		var val, ds;

		if (this.type == "filter")
		{
			var fds = this._filtereddataset ? this._filtereddataset : this._getFilteredDataset();
			ds = this.type == "filter" ? fds : this._innerdataset;
			curidx = this._getRawIndex(ds, curidx);
			ds = this._filtereddataset;
			fds.set_filterstr("");
		}
		else
		{
			ds = this._innerdataset;
		}

		var sel_info = this._selectinfo;
		var ei = {
			preindex: this.index,
			pretext: this.text,
			prevalue: this.value,
			postindex: curidx,
			posttext: ds.getColumn(curidx, datacol || codecol),
			postvalue: ds.getColumn(curidx, codecol || datacol)
		};
/*
		if (this.on_fire_canitemchange(obj, ei.preindex, ei.pretext, ei.prevalue, ei.postindex, ei.posttext, ei.postvalue) == false)
		{
		    this._setEditValue(this.text);

			if (this._isPopupVisible())
			{
				popup_window._closePopup();
			}
			return false;
		}
        */
		this._eventinfo.preindex = ei.preindex;
		this._eventinfo.pretext = ei.pretext;
		this._eventinfo.prevalue = ei.prevalue;
		this._eventinfo.postindex = ei.postindex;
		this._eventinfo.posttext = ei.posttext;
		this._eventinfo.postvalue = ei.postvalue;
		this._eventinfo.isselect = true;

		if (this.index != curidx)
		{
			if (this._isPopupVisible())
			{
				popup_window._closePopup();
			}
		}
		else
		{
			if (this.type != "dropdown")
			{
			    this._setEditValue(this.text);
			}
			if (this._isPopupVisible())
			{
				popup_window._closePopup();
			}
        }

		if (this.comboedit)
	        this.comboedit._setFocus(false);		
        		
		return retv;
	};
                  
	_pCombo._setEditValue = function (v)
	{
	        this.comboedit.set_value(v);
	};
    	
	_pCombo.on_combo_keydown = function (elem, keycode, altKey, ctrlKey, shiftKey, eventBubbles)
	{
	    if (this.readonly || !this.comboedit)
	    {
	        return false;
	    }

	    var E = nexacro.Event;
	    var combo_list = this.combolist;
	    var popup_window = this.popupwindow;
	    var combo_edit = this.comboedit;
	    var fds = this._filtereddataset ? this._filtereddataset : this._getFilteredDataset();
	    var ds = this.type == "filter" ? fds : this._innerdataset;
	    var datacol = this.datacolumn;
	    var codecol = this.codecolumn;
	    var nextidx, rawidx, curidx = this._moverindex;

	    if (curidx < 0)
	    {
	        curidx = this.index;
	    }

	    if (!ds || (!datacol && !codecol))
	    {
	        return;
	    }

	    if (keycode == E.KEY_ESC)
	    {
	        if (this._isPopupVisible())
	        {
	            popup_window._closePopup();
	            this._setEditValue(this.text);
	        }
	        return false;
	    }

	    if (altKey == true && keycode == E.KEY_DOWN)
	    {
	        if (this._isPopupVisible() == true)
	        {
	            popup_window._closePopup();
	        }
	        else
	        {
	            this._showPopup(ds, this.index);
	        }
	        return false;
	    }

	    var sel_info = this._selectinfo;
	    var ei = {
	        preindex: this.index,
	        pretext: this.text,
	        prevalue: this.value,
	        postindex: sel_info.index,
	        posttext: sel_info.text,
	        postvalue: sel_info.value
	    };

	    if (keycode == E.KEY_ENTER)
	    {
	        if (curidx >= 0)
	        {
	            if (this.type == "filter")
	            {
	                rawidx = this._getRawIndex(ds, curidx);
	                rawidx = (rawidx == -1) ? curidx : rawidx;
	                fds.set_filterstr("");
	            }
	            else
	            {
	                rawidx = curidx;
	            }
	        }

	        ei.postindex = rawidx;
	        ei.postvalue = this._getItemValue(rawidx);;
	        ei.posttext = this._getItemText(rawidx);

	        if (this.on_fire_canitemchange(this, ei.preindex, ei.pretext, ei.prevalue, ei.postindex, ei.posttext, ei.postvalue) == false)
	        {
	            this._setEditValue(this.text);
	            if (this._isPopupVisible())
	            {
	                popup_window._closePopup();
	            }
	            return false;
	        }

	        this._setIndex(rawidx);

	        if (this._isPopupVisible())
	        {
	            this._enterkey = true;
	            popup_window._closePopup();
	        }

	        this._eventinfo.isselect = true;
	    }

	    if (keycode == nexacro.Event.KEY_UP || keycode == nexacro.Event.KEY_DOWN)
	    {
	        if (!nexacro._enableaccessibility || ctrlKey || this._isPopupVisible())
	        {
	            if (this._isPopupVisible())
	            {
	                var text;
	                if (keycode == nexacro.Event.KEY_UP)
	                {
	                    if (curidx > 0)
	                    {
	                        var overidx = -1;
	                        if (combo_list._overedItem)
	                        {
	                            overidx = combo_list._overedItem.index;
	                        }
	                        else
	                        {
	                            overidx = curidx;
	                        }

	                        if (overidx == curidx)
	                        {
	                            nextidx = curidx - 1;
	                        }
	                        else
	                        {
	                            nextidx = overidx - 1;
	                        }
	                    }
	                    else
	                    {
	                        nextidx = 0;
	                    }
	                    this._downkey = false;
	                    combo_list._reset_item(nextidx);
	                    combo_list._overeditemindex = nextidx;
	                    this._moverindex = nextidx;
	                    text = ds.getColumn(nextidx, datacol || codecol);
	                    text = text == undefined ? "" : text;
	                    this._setEditValue(text);
	                }
	                else
	                {
	                    var overidx = 0;
	                    if (combo_list._overedItem)
	                    {
	                        overidx = combo_list._overedItem.index;
	                    }
	                    else
	                    {
	                        overidx = curidx;
	                    }

	                    if (overidx == curidx)
	                    {
	                        nextidx = curidx + 1;
	                    }
	                    else
	                    {
	                        nextidx = overidx + 1;
	                    }

	                    if (nextidx < ds.getRowCount())
	                    {
	                        this._downkey = true;
	                        combo_list._reset_item(nextidx);
	                        combo_list._overeditemindex = nextidx;
	                        this._moverindex = nextidx;
	                        text = ds.getColumn(nextidx, datacol || codecol);
	                        text = text == undefined ? "" : text;
	                        this._setEditValue(text);
	                    }
	                }
	            }
	            else
	            {
	                if (keycode == nexacro.Event.KEY_UP)
	                {
	                    if (curidx > 0)
	                    {
	                        nextidx = curidx - 1;
	                    }
	                    else
	                    {
	                        nextidx = 0;
	                    }
	                }
	                else
	                {
	                    if (curidx + 1 < ds.getRowCount())
	                    {
	                        nextidx = curidx + 1;
	                    }
	                    else
	                    {
	                        nextidx = curidx;
	                    }
	                }

	                if (nextidx >= 0)
	                {
	                    if (this.type == "filter")
	                    {
	                        rawidx = this._getRawIndex(ds, nextidx);
	                        rawidx = (rawidx == -1) ? nextidx : rawidx;
	                        fds.set_filterstr("");
	                    }
	                    else
	                    {
	                        rawidx = nextidx;
	                    }
	                }

	                ei.postindex = rawidx;
	                ei.postvalue = this._getItemValue(rawidx);;
	                ei.posttext = this._getItemText(rawidx);

	                if (this.index != rawidx)
	                {
	                    var ret = this.on_fire_canitemchange(this, ei.preindex, ei.pretext, ei.prevalue, ei.postindex, ei.posttext, ei.postvalue);
	                    if (ret)
	                    {
	                        this._setIndex(rawidx);
	                    }
	                }
	            }

	            this._getWindow()._keydown_element._event_stop = true;
	        }// if(!nexacro._enableaccessibility || ctrlKey)
	        this._getWindow()._keydown_element._event_stop = true;
	        return false;
	    }
	    return false;
	};

	if (nexacro.Browser == "Gecko")
	{

		_pCombo.on_fire_sys_onkeyup = function (key_code, alt_key, ctrl_key, shift_key, from_comp, from_refer_comp)
		{
		    var popup_window = this.popupwindow;
		    if (this.comboedit.value == null || this.comboedit.value == "")
		    {
		        if (popup_window._is_popup())
		        {
		            popup_window._closePopup();
		        }
		    }
			var ret = nexacro.Component.prototype.on_fire_sys_onkeyup.call(this, key_code, alt_key, ctrl_key, shift_key, from_comp, from_refer_comp);

			if (key_code == nexacro.Event.KEY_UP || key_code == nexacro.Event.KEY_DOWN)
			{
				if (this.type == "dropdown")
					this.comboedit.setCaretPos(0);
			}

			return ret;
		};
		_pCombo._eachColosePopup = nexacro._emptyFn;
	}
    else
    {
        _pCombo._eachColosePopup = function (val)
        {
            var popup_window = this.popupwindow;
            if (popup_window._is_popup())
            {
                popup_window._closePopup();
            }
        };
    }

	_pCombo.on_fire_onkillfocus = function (obj, fromObj)
	{
	    if (this._text_change == true)
		{
	        this._setEditValue(this.text);
		}

		if (this.combolist)
		{
			this.combolist._reset_item(this.index);
			this.combolist._overeditemindex = -1;
			this._moverindex = -1;
		}

		if (this._isPopupVisible())
		{
			this.popupwindow._closePopup();
			this._setEditValue(this.text);
		}

		if (this.comboedit)
		{
		    this.comboedit._on_killfocus(obj, fromObj);

		    this.comboedit._stat_change("notfocus", "normal");

		}
		nexacro.Component.prototype.on_fire_onkillfocus.call(this, obj, fromObj);
	};

	_pCombo.on_notify_edit_onlbuttondown = function (obj, e)
	{
		if (this.readonly) return false;
		var popup_window = this.popupwindow;

		if (this._isPopupVisible() == true)
		{
			popup_window._closePopup();
		}
		else
		{
			if (this.type == "dropdown")
			{
				this._showPopup(this._innerdataset, this.index);
			}
		}
		return false;
	};

	_pCombo.on_fire_user_onlbuttonup = function (button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY, from_comp, from_refer_comp)
	{
		var ret = nexacro.Component.prototype.on_fire_user_onlbuttonup.call(this, button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY, from_comp, from_refer_comp);
		return ret;
	};

    _pCombo.on_fire_sys_onlbuttonup = function (button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY, from_comp, from_refer_comp, from_elem)
	{
	    var upelem = this._is_real_upelem;
	    this._is_real_upelem = null;

		if (from_refer_comp instanceof nexacro.ScrollBarCtrl) return;
        if (from_refer_comp && from_refer_comp.parent instanceof nexacro.ScrollBarCtrl) return;

        var ret = nexacro.Component.prototype.on_fire_sys_onlbuttonup.call(this, button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY, from_comp, from_refer_comp, from_elem);

        var window = this._getWindow();
        var down_id = "";
        var compinfo = window.findComponent(window._cur_ldown_elem, 0, 0);
        if (compinfo && compinfo[0])
            down_id = compinfo[0]._unique_id;

        var up_id = "";
        compinfo = window.findComponent(from_elem, 0, 0);
        if (compinfo && compinfo[0])
            up_id = compinfo[0]._unique_id;

        if (down_id != up_id) return;

		var moveredidx = -1;
		var preindex = this.index;
		var pretext = this.text;
		var prevalue = this.value;
		var combolist = this.combolist;
		var comboedit = this.comboedit;
		var sel_info = combolist && combolist._selectinfo;

		if (combolist)
		{
			moveredidx = combolist._overeditemindex;
		}

		if (this.visible && this._isEnable() && this._isPopupVisible())
		{
			if (combolist)
			{
				if (moveredidx > -1)
				{
					if (preindex != moveredidx)
					{
						if (sel_info.index == moveredidx)
						{
							this._setIndex(preindex);
						}
						else
						{
							this._setIndex(moveredidx);
						}
						if (upelem && this._isPopupVisible())
						{
						    this.popupwindow._closePopup();
						}
					}
					else
					{
						this._setIndex(preindex);
					}

					if (comboedit)
					{
					    if (!(nexacro.isTouchInteraction && nexacro.SupportTouch))
					    {
					        comboedit.on_apply_custom_setfocus();
					    }
					}
				}
				else
				{
					this._setIndex(preindex);
				}

			}
		}
        				
		return ret;
	};

	_pCombo.on_fire_user_onkeydown = function (keycode, alt_key, ctrl_key, shift_key, fire_comp, refer_comp)
	{
		var ret = nexacro.Component.prototype.on_fire_user_onkeydown.call(this, keycode, alt_key, ctrl_key, shift_key, fire_comp, refer_comp);
		return ret;
	};

	_pCombo.on_fire_sys_onkeydown = function (keycode, alt_key, ctrl_key, shift_key, fire_comp, refer_comp)
	{
		var ret = nexacro.Component.prototype.on_fire_sys_onkeydown.call(this, keycode, alt_key, ctrl_key, shift_key, fire_comp, refer_comp);
		this.on_combo_keydown(null, keycode, alt_key, ctrl_key, shift_key, 0);
		return ret;
	};

	_pCombo._on_mousewheel = function (elem, wheelDeltaX, wheelDeltaY, button, alt_key, ctrl_key, shift_key, canvasX, canvasY, screenX, screenY, event_bubbles, fire_comp, refer_comp, bScroll)
	{
	    if (this.popupwindow && this.popupwindow._is_popup())
	    {
            if(this.combolist)
                this.combolist._on_mousewheel(elem, wheelDeltaX, wheelDeltaY, button, alt_key, ctrl_key, shift_key, canvasX, canvasY, screenX, screenY, event_bubbles, fire_comp, refer_comp, bScroll);
	    }
		return true;
	}
    
	_pCombo.on_fire_sys_onmousewheel = function (wheelDeltaX, wheelDeltaY, button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY, comp, refer_comp)
	{
	    if (this.readonly) return false;
        var last_focus = this._find_lastFocused();
        if ((this != last_focus && !this._is_subcontrol) || (this.parent != last_focus && this._is_subcontrol)) return;
	    if (!this.popupwindow || !this.popupwindow._is_popup())
	    {
	        var fds = this._filtereddataset ? this._filtereddataset : this._getFilteredDataset();
	        var ds = this.type == "filter" ? fds : this._innerdataset;
	        var curidx = this.index;
	        var nextidx = 0;

	        
	        if (wheelDeltaY > 0)
	        {
	            if (curidx > 0)
	            {
	                nextidx = curidx - 1;
	            }
	            else
	            {
	                nextidx = 0;
	            }
	            this._setIndex(nextidx);
	        }
	        else
	        {
	            nextidx = curidx + 1;
	            if (nextidx < ds.getRowCount())
	            {
	                this._setIndex(nextidx);
	            }
	        }
	    }
	    return true;
	};
    	
	_pCombo.on_fire_sys_onslide = function (elem, touch_manager, touchinfos, xaccvalue, yaccvalue, xdeltavalue, ydeltavalue, from_comp, from_refer_comp)
	{
	    var ret = nexacro.Component.prototype.on_fire_sys_onslide.call(this, elem, touch_manager, touchinfos, xaccvalue, yaccvalue, xdeltavalue, ydeltavalue, from_comp, from_refer_comp);

	    this._update_popupwindow_position();

	    return ret;
	};
    
	_pCombo.on_fire_sys_onfling = function (elem, fling_handler, xstartvalue, ystartvalue, xdeltavalue, ydeltavalue, touchlen, from_comp, from_refer_comp)
	{
	    var ret = nexacro.Component.prototype.on_fire_sys_onfling.call(this, elem, fling_handler, xstartvalue, ystartvalue, xdeltavalue, ydeltavalue, touchlen, from_comp, from_refer_comp);

	    this._update_popupwindow_position();

	    return ret;
	};
    
	
	_pCombo.on_notify_edit_cancharchange = function (obj, e)
	{
		if (this.cancharchange && this.cancharchange._has_handlers)
		{
			e.fromobject = this;
			var ret = this.cancharchange._fireCheckEvent(this, e);
			if (!ret)
			{
				this.value = pretext;
				this.text = pretext;
				this._setEditValue(this.text);
			}
			return nexacro._toBoolean(ret);
		}
		return true;
	};

	_pCombo.on_notify_edit_onchar = function (obj, e)
	{
		if (this.onchar && this.onchar._has_handlers)
		{
			var evt = new nexacro.TextChangeEventInfo(obj, e.chartext, e.pretext, e.posttext);
			var ret = this.onchar._fireCheckEvent(this, evt);
			return nexacro._toBoolean(ret);
		}
		return true;
	};

	_pCombo.on_notify_edit_ontextchange = function (obj, e)
	{
	    return this.on_fire_ontextchange(obj, e);
	};

	_pCombo.on_notify_edit_ontextchanged = function (obj, e)
	{
	    return this.on_fire_ontextchanged(obj, e);
	};

	_pCombo.on_fire_ontextchange = function (obj, e)
	{
		if (this.ontextchange && this.ontextchange._has_handlers)
		{
			e.fromobject = this;
			var ret = this.ontextchange._fireCheckEvent(this, e);
            if (e.pretext != e.posttext)
			{
			    this._text_change = true;
            }
			return nexacro._toBoolean(ret);
		}
		return true;
	};

	_pCombo.on_fire_ontextchanged = function (obj, e)
	{
	    var ret = false;

	    if (this.ontextchanged && this.ontextchanged._has_handlers)
	    {
	        e.fromobject = this;
	        ret = this.ontextchanged._fireEvent(this, e);
	    }
	    this.on_combo_text_changed(e.pretext, e.posttext);
	    return nexacro._toBoolean(ret);
	};


	_pCombo.on_notify_edit_oneditclick = function (obj, e)
	{
	    //on touch devices, application.enabletouchevent == false
	    if (nexacro.isTouchInteraction && nexacro.SupportTouch && !application.enabletouchevent)
	    {
	        var evt = new nexacro.EventInfo(this, "oneditclick");
	        this.on_notify_edit_onlbuttondown(this, evt);
	    }

		if (this.oneditclick && this.oneditclick._has_handlers)
		{
			e.fromobject = this;
			var ret = this.oneditclick._fireEvent(this, e);
			return nexacro._toBoolean(ret);
		}
		return true;
	};

	_pCombo.on_combo_text_changed = function (pretext, posttext)
	{
		if (this.readonly || !this.comboedit)
		{
			return false;
		}

        if ((this.type != "dropdown") && (this.onkeydown && this.onkeydown.defaultprevented === true))
		{
			this.comboedit.set_value("");
			return;
		}

		var fds = this._filtereddataset ? this._filtereddataset : this._getFilteredDataset();
		var ds = this.type == "filter" ? fds : this._innerdataset;

		if (!this.combolist && this.type != "dropdown")
		{
			this._createList(ds);
		}

		var col = this.datacolumn || this.codecolumn;
		var keyval = posttext;
		var combo_edit = this.comboedit;
		var combo_list = this.combolist;
		var popup_window = this.popupwindow;
		this._keyval = keyval;

		if (keyval === "")
		{
            this._text_change = true;
		    this._eachColosePopup();
			return;
		}

		switch (this.type)
		{
			case "search":
			    var index = ds.findRowAs(col, keyval);

				if (index >= 0)
				{
				    var flag_backspace = false;
				    if (combo_edit._edit_base_api && combo_edit._edit_base_api._charcode == nexacro.Event.KEY_BACKSPACE)
				        flag_backspace = true;				                        

					if (!popup_window._is_popup())
					{
					    this._text_change = true;
						this._showPopup(ds, index);
					}
					else
					{
						this._showPopup(ds, index);
					}
				}
				else
				{
				    if (popup_window._is_popup())
				    {
				        popup_window._closePopup();
				    }
				}
				break;
			case "filter":
				ds.set_filterstr("");
				ds.set_filterstr(col + ".match('" + keyval + "')");

				if (ds.getRowCount() > 0)
				{
					combo_list._overeditemindex = 0;
					this._moverindex = 0;
					this._text_change = true;
					this._showPopup(ds, 0);
				}
				else
				{
				    if (popup_window._is_popup())
				    {
				        popup_window._closePopup();
				    }
				}
				break;
		}
        this._keyval = undefined;
	};

	_pCombo.on_fire_onitemclick = function (obj, index, itemtext, itemvalue, button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY)
	{
		if (this.onitemclick && this.onitemclick._has_handlers)
		{
			var evt = new nexacro.ItemClickEventInfo(obj, "onitemclick", index, itemtext, itemvalue, button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY);
			this.onitemclick._fireEvent(this, evt);
		}
		return false;
	};

	_pCombo.on_fire_onitemchanged = function (obj, preindex, pretext, prevalue, postindex, posttext, postvalue)
	{
		this.applyto_bindSource("value", obj.value);

		var sel_info = this._selectinfo;
		sel_info.index = postindex;
		sel_info.text = posttext;
		sel_info.value = postvalue;

		this._eventinfo.preindex = preindex;
		this._eventinfo.pretext = pretext;
		this._eventinfo.prevalue = prevalue;
		this._eventinfo.postindex = postindex;
		this._eventinfo.posttext = posttext;
		this._eventinfo.postvalue = postvalue;
		this._eventinfo.isselect = true;

		if (this.onitemchanged && this.onitemchanged._has_handlers)
		{
			var evt = new nexacro.ItemChangeEventInfo(this, "onitemchanged", preindex, pretext, prevalue, postindex, posttext, postvalue);
			this.onitemchanged._fireEvent(this, evt);
		}
		return false;
	};

	_pCombo.on_fire_canitemchange = function (obj, preindex, pretext, prevalue, postindex, posttext, postvalue)
	{
		if (this.canitemchange && this.canitemchange._has_handlers)
		{
			var evt = new nexacro.ItemChangeEventInfo(this, "canitemchange", preindex, pretext, prevalue, postindex, posttext, postvalue);
			var ret = this.canitemchange._fireCheckEvent(this, evt);
			return nexacro._toBoolean(ret);
		}
		return true;
	};

	_pCombo.on_fire_ondropdown = function (obj)
	{
		if (this.ondropdown && this.ondropdown._has_handlers)
		{
			var evt = new nexacro.EventInfo(this, "ondropdown");
			evt.postvalue = this.value;
			var ret = this.ondropdown._fireEvent(this, evt);
			if (ret == undefined) ret = true;
			return nexacro._toBoolean(ret);
		}
		return true;
	};

	_pCombo.on_fire_oncloseup = function (obj, beforeIndex, beforeText, beforeValue, afterIndex, afterText, afterValue, isSelect)
	{
	    var _window = this._getWindow();
	    if (_window && this._track_capture)
	    {
	        _window._releaseCaptureLock(this);
	    }

	    var listidx;
		if (this.combolist)
		{
		    listidx = this.combolist.index;

		    if (this.type == "filter")
		    {
		        listidx = this._getRawToListindex(listidx);
		    }
		    if (!this._enterkey) this.combolist._reset_item(listidx);
			this._enterkey = false;
			this.combolist._overeditemindex = -1;
			this._moverindex = -1;
			if (this.combolist._overedItem) this.combolist._overedItem = null;
		}

		if (isSelect == false && (this.combolist && this.index != listidx))
		{
			if ((beforeText == afterText) && (this._keyval !== "") && (this._text_change == false))
			{
			    this._setEditValue(this.text);
			}

			if (this.combolist)
			{
			    if (this.type == "filter")
			    {
			        beforeIndex = this._getRawToListindex(beforeIndex);
			    }
				this.combolist.index = beforeIndex;
				this.combolist.on_apply_index(beforeIndex);
			}
		}

		if (this.oncloseup && this.oncloseup._has_handlers)
		{
			var evt = new nexacro.ComboCloseUpEventInfo(this, "oncloseup", beforeIndex, beforeText, beforeValue, afterIndex, afterText, afterValue, isSelect);
			var ret = this.oncloseup._fireEvent(this, evt);
			return nexacro._toBoolean(ret);
		}
		return false;
	};

	// ==============================================================================
	// nexacro.Combo : Logical Part ( Internal Function Part )
	// ==============================================================================
	_pCombo._applyZoomPopup = function ()
	{
	    if (this.popupwindow && this.popupwindow._is_popup())
	    {
	        if (this.enable === false || this.readonly === true || this.visible === false) return;

	        var fds = this._filtereddataset ? this._filtereddataset : this._getFilteredDataset();
	        var ds = this.type == "filter" ? fds : this._innerdataset;
	        if (ds && ds.rowcount == 0)
	            ds = this._innerdataset;

	        this._showPopup(ds, this.index);
	    }
	};

	_pCombo._setIndex = function (v, bIgnoreCompareIdx)
	{
		if (bIgnoreCompareIdx || v != this.index)
		{
			var curidx = this._moverindex;
			var codecol = this.codecolumn;
			var datacol = this.datacolumn;
			var val, ds;

			if (this.type == "filter")
			{
				ds = this._filtereddataset;
			}
			else
			{
				ds = this._innerdataset;
			}

			if (!ds)
				return;

			v = parseInt(v, 10) | 0;

			this._preindex = this.index;
			this._pretext = this.text;
			this._prevalue = this.value;
			this.index = v;
			this.on_apply_index();

			var ei = {
				preindex: this._preindex,
				pretext: this._pretext,
				prevalue: this._prevalue,
				postindex: this.index,
				posttext: this.text,
				postvalue: this.value
			};
			this.on_fire_onitemchanged(this, ei.preindex, ei.pretext, ei.prevalue, ei.postindex, ei.posttext, ei.postvalue);
		}
		return v;
	};

	_pCombo._recalcLayout = function ()
	{
		if (!this.getElement() || !this._is_created_contents)
		{
			return;
		}

		var comboedit = this.comboedit;
		var dropbutton = this.dropbutton;
		var btn_size = 0;
		var client_width = this._client_width;
		var client_height = this._client_height;
		var client_left = this._client_left;
		var client_top = this._client_top;

		var style_btnsize = this.on_find_CurrentStyle_buttonsize("normal");

		if (!style_btnsize || style_btnsize._is_empty)
		{
			btn_size = client_height;
		}
		else if (parseInt(style_btnsize._value, 10) > client_width)
		{
			btn_size = client_width;
		}
		else
		{
			btn_size = parseInt(style_btnsize._value, 10) | 0;
			if (btn_size < 0)
			{
				btn_size = client_height;
			}
		}

		if (dropbutton)
		{
			var btn_left = client_width - btn_size;
			var btn_top = client_top;
			var btn_width = btn_size;
			var btn_height = client_height;

			var btn_margin = dropbutton.on_find_CurrentStyle_margin("normal");
			if (btn_margin && !btn_margin._is_empty)
			{
				btn_left = btn_left + btn_margin.left;
				btn_top = btn_margin.top;
				btn_width = btn_size - btn_margin.left - btn_margin.right;
				btn_height = client_height - btn_margin.top - btn_margin.bottom;
			}
			dropbutton.move(btn_left, btn_top, btn_width, btn_height, null, null);
		}

		if (comboedit)
		{
			var edit_left = client_left;
			var edit_top = client_top;
			var edit_width = client_width - btn_size - 1;
			var edit_height = client_height;

			var edit_margin = comboedit.on_find_CurrentStyle_margin("normal");
			if (edit_margin && !edit_margin._is_empty)
			{
				edit_left = edit_margin.left;
				edit_top = edit_margin.top;
				edit_width = edit_width - edit_margin.left - edit_margin.right;
				edit_height = edit_height - edit_margin.top - edit_margin.bottom;
			}
			comboedit.move(edit_left, edit_top, edit_width, edit_height, null, null);
		}
	}

	_pCombo._getMaxTextSize = function (ds)
	{
		var col = this.datacolumn || this.codecolumn;
		var combolist = this.combolist;
		if (!ds || !col || !combolist) return false;

		return combolist._getMaxTextSize();
	};

	_pCombo._isPopupVisible = function ()
	{
		var popupwindow = this.popupwindow;
		if (popupwindow && popupwindow.visible == true)
			return true;
		else
			return false;
	};

	_pCombo._createListOnly = function (ds)
	{
	    var datacol = this.datacolumn;
	    var codecol = this.codecolumn;
	    var combolist = this.combolist;

	    if (!ds || ds && ds.getRowCount() <= 0 || (!datacol && !codecol)) return;

	    if (!combolist)
	    {
	        this._exprcache = {};
	        
	        combolist = this.combolist = new nexacro.ComboListCtrl("combolist", "absolute", 0, 0, 1, 1, null, null, this);
	        combolist.set_scrollbars("autovert");
	        combolist.set_codecolumn(codecol);
	        combolist.set_datacolumn(datacol);
	        this.on_apply_innerdataset();

	        combolist.createComponent(true);
	        combolist._setEventHandler("onitemclick", this.on_notify_item_onitemclick, this);
	        combolist._setEventHandler("canitemchange", this.on_notify_item_canitemchange, this);
	        combolist._setEventHandler("onitemchanged", this.on_notify_item_onitemchanged, this);
	    }
	};

	_pCombo._createList = function (ds, max_width, max_height)
	{
		var datacol = this.datacolumn;
		var codecol = this.codecolumn;

		if (!ds || ds && ds.getRowCount() <= 0 || (!datacol && !codecol)) return;

		if (!this.combolist)
		    this._createListOnly(ds);

		var combolist = this.combolist;

		var popupwindow = this.popupwindow;
		if (!popupwindow)
		{
			popupwindow = this.popupwindow = new nexacro.ComboPopupWindow("combopopup", "absolute", 0, 0, 0, 0, null, null, this);
		    popupwindow._track_capture = false;
		}

		if (!popupwindow._is_created)
		{
			popupwindow.createComponent(true);
			popupwindow._attach(combolist);
			popupwindow.on_created();
		}

		if (!combolist._is_created)
		{
		    var control_elem = combolist._control_element;
		    if (control_elem && control_elem._adjust_height == null)
		    {
		        if (max_width != undefined && max_height != undefined)
		        {
		            control_elem.setElementSize(max_width, max_height);
		        }
		        else
		        {
		            var size = this._getPopuplistSize(ds);
		            var width = size.width;
		            var height = size.height;
		            control_elem.setElementSize(width, height);
		        }
		    }

			combolist.on_created();
		    combolist.getElement().setElementToolTip("", combolist.getElement().tooltiptype);   // default로 들어간 combolist title 삭제
		}
	};

	_pCombo._update_popupwindow_position = function ()
	{
	    var popupwindow = this.popupwindow;
	    if (popupwindow)
	    {
	        var popup_control_elem = popupwindow._control_element;

	        var pos = nexacro._getElementPositionInFrame(this._control_element);
	        var cal_winpos_left = pos.x;
	        var cal_winpos_top = pos.y;

            // TODO Element의 bottom 좌표를 바로 얻는 API로 바꾸는게 바람직 (현재 없음)
	        var scale = this._getCumulativeZoomFactor() / 100.0;
	        var left = cal_winpos_left;
	        var top = cal_winpos_top + (this._adjust_height * scale);

	        popup_control_elem.setElementPosition(left, top);
	    }
	};

	_pCombo._showPopup = function (ds, index)
	{
	    var is_change_index = false;
	    var pre_idx = this.index;

		if (this.on_fire_ondropdown(this) == false)
		{
			return;
		}

		if (pre_idx != this.index)
		    is_change_index = true;		

		if ((this.ondropdown && this.dropdown.preventable && this.ondropdown.defaultprevented === true) || !ds || (ds && ds.getRowCount() == 0))
		{
			return;
		}

	    if (is_change_index)        
	        index = this.index;

	    this._createListOnly(ds);

	    // 모든 item을 보여주기 위해 필요한 크기
	    var size = this._getPopuplistSize(ds);
	    var width = size.width;
	    var height = size.height;

	    if (height > 700)
	    {
	        /*
            var offs = nexacro._getCompOffsetSize(this);
            width = Math.min(width, offs.width);
            height = Math.min(height, offs.height);
            */

	        // getcompOffsetSize는 Scale 되지 않은 좌표를 넘기고 있어서 정확하지가 않음.
	        // API화 하는것이 좋겠으나 전체적으로 검토가 필요.....

	        var offs = { x: 0, y: 0 };
	        var w = this._getWindow();
	        var w_w = w.getWidth();
	        var w_h = w.getHeight();

	        var pos = nexacro._getElementPositionInFrame(this._control_element);
	        var scale = this._getCumulativeZoomFactor() / 100.0;

	        offs.width = w_w - pos.x + (this._adjust_width * scale);
	        width = Math.min(width, offs.width / scale);

	        offs.height = w_h - pos.y + (this._adjust_height * scale);
	        height = Math.min(height, offs.height / scale);
	    }

	    this._createList(ds, width, height);

		var combolist = this.combolist;
		var popupwindow = this.popupwindow;
        if (nexacro._enableaccessibility)
            this._want_arrows = true;

		if (combolist)
		{
            popupwindow._popupAuto(width, height);

		    combolist.setInnerDataset(ds);
		    combolist.set_index(index);
            combolist._reset_item(index);

			if (index == -1 && combolist.vscrollbar)
			{
			    combolist.getElement().setElementVScrollPos(0);
			}

			var _window = this._getWindow();
			if (_window && this._track_capture)
			{
			    if (_window._getCaptureComp(true, false) != this)
			    _window._setCaptureLock(this, true, false);
			}
		}
	};

	_pCombo._closePopup = function ()
	{
	    var popupwindow = this.popupwindow;
	    if (popupwindow)
	        popupwindow._closePopup();

	    popupwindow = null;
	};

    // 리스트 전체를 보여주는데 필요한 pixel 크기를 리턴함.
    // zoom은 배제되어있음
	_pCombo._getPopuplistSize = function (ds)
	{
	    var combolist = this.combolist;
        var curstyle = this.currentstyle;
		var ds_cnt = ds.getRowCount();
		var display_cnt = this.displayrowcount < ds_cnt ? this.displayrowcount : ds_cnt;

		var totalw, totalh;
		var textw = this._getMaxTextSize(ds);
        var itemh = parseInt(combolist.currentstyle.itemheight._value, 10);

		var cl_p = combolist.on_find_CurrentStyle_padding(this._pseudo);
		var cl_b = combolist.on_find_CurrentStyle_border(this._pseudo);

		var item_p = combolist.on_find_CurrentStyle_itempadding(this._pseudo);
		var item_b = combolist.on_find_CurrentStyle_itemborder(this._pseudo);

		var cl_pw = cl_p ? cl_p._getPaddingWidth() : 0;
		var cl_ph = cl_p ? cl_p._getPaddingHeight() : 0;
		var cl_bw = cl_b ? cl_b._getBorderWidth() : 0;
		var cl_bh = cl_b ? cl_b._getBorderHeight() : 0;

		var item_pw = item_p ? item_p._getPaddingWidth() : 0;
		var item_bw = item_b ? item_b._getBorderWidth() : 0;

		totalh = display_cnt <= 0 ? itemh * ds_cnt : itemh * display_cnt;
		totalh += cl_ph + cl_bh;
		textw += cl_pw + cl_bw;
		totalw = Math.max(this._adjust_width, textw);

		return { width: totalw, height: totalh };
	};

	_pCombo._getRawToListindex = function (idx)
	{
	    if (this.type == "filter")
	    {
	        var fds = this._filtereddataset ? this._filtereddataset : this._getFilteredDataset();
	        var row_count = fds._viewRecords.length;
	        var idsArr = fds._viewRecords;

	        for (var i = 0; i < row_count; i++)
	        {
	            if (idsArr[i]._rawidx == idx)
	                return i;
	        }
	    }
        return idx;
	};

	_pCombo._getRawIndex = function (fds, idx)
	{
		var ids = this._innerdataset;

		if (idx == -1 || (fds._viewRecords.length <= idx)) return -1;

		var rawidx = fds._viewRecords[idx]._rawidx;
	    var idsArr = ids._rawRecords;
	    var row_count = idsArr.length;

		for (var i = 0; i < row_count; i++)
		{
			if (idsArr[i]._rawidx == rawidx)
			{
				return rawidx;
			}
		}
		return -1;
	};

	_pCombo._getFilteredDataset = function ()
	{
		if (!this._filtereddataset)
		{
			this._createFilteredDataset();
		}
		return this._filtereddataset;
	};

	_pCombo._createFilteredDataset = function ()
	{
		var fds = this._filtereddataset;
		var codecol = this.codecolumn;
		var datacol = this.datacolumn;
		var ids = this._innerdataset;

		if (!ids || ids && ids.getRowCount() <= 0 || !datacol && !codecol) return;

		var row_count = ids.getRowCount();

		if (!fds)
		{
			fds = this._filtereddataset = new nexacro.Dataset("filter_" + this.id);
			fds.addColumn(codecol, "string");
			fds.addColumn(datacol, "string");

			for (var i = 0; i < row_count; i++)
			{
				fds.insertRow(i);
				fds.setColumn(i, codecol, ids.getColumn(i, codecol));
				fds.setColumn(i, datacol, ids.getColumn(i, datacol));
			}
		}
		else
		{
		    if (this.combolist)
		    {
		        this.combolist._userDsChange = true;

		        fds.clearData();
		        for (var i = 0; i < row_count; i++)
		        {
		            fds.insertRow(i);
		            fds.setColumn(i, codecol, ids.getColumn(i, codecol));
		            fds.setColumn(i, datacol, ids.getColumn(i, datacol));
		        }

		        this.combolist._userDsChange = false;
		        this.combolist.redraw();
		    }
		    else
		    {
		        fds.clearData();
		        for (var i = 0; i < row_count; i++)
		        {
		            fds.insertRow(i);
		            fds.setColumn(i, codecol, ids.getColumn(i, codecol));
		            fds.setColumn(i, datacol, ids.getColumn(i, datacol));
		        }
		    }
		}
	};

	_pCombo._getDragData = function ()
	{
		if (this.comboedit && this.comboedit.getSelectedText)
			return this.comboedit.getSelectedText();
	};

	_pCombo._recheckValue = function ()
	{
		var ds = this._innerdataset;
		var _combo_edit = this.comboedit;
		if (!_combo_edit) return false;
		if (this.value !== undefined)
		{
			if (ds)
			{
				var row_count = ds.getRowCount();
				for (var i = 0; i < row_count; i++)
				{
					if (this.value == this._getItemValue(i))
					{
						this.index = i;
						this.text = this._getItemText(i);
						this.redraw();
						return;
					}
				}

				this.index = -1;
				this.text = "";
				this.redraw();
				return;
			}
		}

		if (this.text != "")
		{
			if (ds)
			{
				var row_count = ds.getRowCount();
				for (var i = 0; i < row_count; i++)
				{
					if (this.text == this._getItemText(i))
					{
						this.index = i;
						this.value = this._getItemValue(i);
						this.redraw();
						return;
					}
				}
			}
		}

		if (this.index != -1)
		{
			if (ds)
			{
				if (this.index < ds.getRowCount())
				{
					this.value = this._getItemValue(this.index);
					this.text = this._getItemText(this.index);
					this.redraw();
					return;
				}
			}
		}

		this.index = -1;
		this.value = undefined;
		this.text = "";

		if (!ds)
		{
			this.redraw();
		}
	};

	_pCombo._getItemValue = function (index)
	{
		var ds = this._innerdataset;
		var column = this.codecolumn || this.datacolumn;
		var rtn;

		if (ds && column)
		{
			rtn = ds.getColumn(index, column);
			if (rtn == undefined && this.type == "filter") rtn = this._innerdataset.getColumn(index, column);
			return rtn;
		}
		return null;
	};

	_pCombo._getItemText = function (index)
	{
		var ds = this._innerdataset;
		var column = this.datacolumn || this.codecolumn;
		var rtn;

		if (ds && column)
		{
			rtn = ds.getColumn(index, column);
			if (rtn == undefined && this.type == "filter") rtn = this._innerdataset.getColumn(index, column);
			return rtn;
		}
		return null;
	};

	_pCombo._getIndex = function (value)
	{
	    var fds = this._filtereddataset ? this._filtereddataset : this._getFilteredDataset();
	    var ds = this.type == "filter" ? fds : this._innerdataset;

	    if (ds)
	    {
	        var row_count = ds.getRowCount();
	        for (var i = 0; i < row_count; i++)
	        {
	            var v = this._getItemValue(i);
	            if (value instanceof nexacro.Decimal)
	            {
	                value = value.toString();
	            }
	            if (v instanceof nexacro.Decimal)
	            {
	                v = v.toString();
	            }

	            if (value == v)
	            {
	                return i;
	            }
	        }
	    }
	    return -1;
	};

	delete _pCombo;
	_pCombo = null;


	// ==============================================================================
	// nexacro.ComboListCtrl ( Combo SubCtrol 1 )
	// ==============================================================================
	nexacro.ComboListCtrl = function (id, position, left, top, width, height, right, bottom, parent)
	{
		nexacro.ListBoxCtrl.call(this, id, position, left, top, width, height, right, bottom, parent);

		this._default_itemheight = nexacro._getCachedStyleObj("itemheight", "20");
		this._overedItem = null;

	};

	var _pComboListCtrl = nexacro._createPrototype(nexacro.ListBoxCtrl, nexacro.ComboListCtrl);
	nexacro.ComboListCtrl.prototype = _pComboListCtrl;

	//---------------------------------------------------------------
	// nexacro.ComboListCtrl : Style
	//--------------------------------------------------------------- 
	_pComboListCtrl.on_find_CurrentStyle_itemheight = function (pseudo)
	{
		return this.parent.on_find_CurrentStyle_itemheight(pseudo) || this._default_itemheight;
	};

	_pComboListCtrl.on_find_CurrentStyle_border = function (pseudo)
	{
		var style = this._find_pseudo_obj("border", pseudo, "border");
		return style;
	};

	_pComboListCtrl.on_find_CurrentStyle_itembackground = function (pseudo)
	{
	    return this.parent._find_pseudo_obj("itembackground", pseudo, "background") || this._find_pseudo_obj("itembackground", pseudo, "background");
	};

	_pComboListCtrl.on_find_CurrentStyle_itemgradation = function (pseudo)
	{
		return this.parent._find_pseudo_obj("itemgradation", pseudo, "gradation") || this._find_pseudo_obj("itemgradation", pseudo, "gradation");
	};

	_pComboListCtrl.on_find_CurrentStyle_itemborder = function (pseudo)
	{
	    return this.parent._find_pseudo_obj("itemborder", pseudo, "border") || this._find_pseudo_obj("itemborder", pseudo, "border");
	};

	_pComboListCtrl.on_find_CurrentStyle_itembordertype = function (pseudo)
	{
	    return this.parent._find_pseudo_obj("itembordertype", pseudo, "bordertype") || this._find_pseudo_obj("itembordertype", pseudo, "bordertype");
	};

	_pComboListCtrl.on_find_CurrentStyle_itempadding = function (pseudo)
	{
	    return this.parent._find_pseudo_obj("itempadding", pseudo, "padding") || this._find_pseudo_obj("itempadding", pseudo, "padding");
	};

	_pComboListCtrl.on_find_CurrentStyle_itemaccessibility = function (pseudo)
	{
	    return this.parent._find_pseudo_obj("itemaccessibility", pseudo, "accessibility") || this._find_pseudo_obj("itemaccessibility", pseudo, "accessibility") || nexacro.Component._default_accessibility;
	};

	_pComboListCtrl.on_find_CurrentStyle_color = function (pseudo)
	{
		return this.parent._find_pseudo_obj("itemcolor", pseudo, "color") || this._find_inherit_pseudo_obj("color", pseudo, "color") || nexacro.Component._default_color;
	};

	_pComboListCtrl.on_find_CurrentStyle_font = function (pseudo)
	{
		return this.parent._find_pseudo_obj("itemfont", pseudo, "font") || this._find_inherit_pseudo_obj("font", pseudo, "font") || nexacro.Component._default_font;
	};

	//---------------------------------------------------------------
	// nexacro.ComboListCtrl : Event Handlers
	//--------------------------------------------------------------- 
	_pComboListCtrl._on_mousewheel = function (elem, wheelDeltaX, wheelDeltaY, button, alt_key, ctrl_key, shift_key, canvasX, canvasY, screenX, screenY, event_bubbles, fire_comp, refer_comp, bScroll)
	{
	    nexacro.Component.prototype._on_mousewheel.call(this, elem, wheelDeltaX, wheelDeltaY, button, alt_key, ctrl_key, shift_key, canvasX, canvasY, screenX, screenY, event_bubbles, fire_comp, refer_comp, bScroll);
		return false;
	};

	_pComboListCtrl.on_notify_item_onmouseenter = function (obj, e)
	{
	};

	_pComboListCtrl.on_notify_item_onmouseleave = function (obj, e)
	{
	};

	//---------------------------------------------------------------
	// nexacro.ComboListCtrl : Logical Part
	//--------------------------------------------------------------- 
	_pComboListCtrl._create_item = function (id, position, left, top, width, height, right, bottom, parent)
	{
		return new nexacro.ComboListItemCtrl(id, position, left, top, width, height, right, bottom, parent);
	};

	_pComboListCtrl._reset_item = function (rowidx)
	{
		var curIndex, vpos;
		var control_elem = this.getElement();

		var preidx = this.index;

	    if (this._overedItem)
	        preidx = this._overedItem.index;

		var currVScrollTopPos = control_elem.scroll_top == undefined ? 0 : control_elem.scroll_top;
		var listbottom = this._adjust_top + this._adjust_height;
	    var itemGap, nextTopPos, nextBottom;
		var visible_end = this._get_last_visible_row(true);
	    var nextHeight = parseInt(this.currentstyle.itemheight._value, 10);
	    var rowcount = this._get_rowcount();

	    if (rowidx >= rowcount)
	        return;

	    nextTopPos = (rowidx < 0 ? 0 : rowidx) * nextHeight;
			nextBottom = nextTopPos + nextHeight;

			if (nextBottom > listbottom)
			{
				itemGap = nextBottom - listbottom;
			}

	    if ((preidx != rowidx) && (nextTopPos >= this._client_height + currVScrollTopPos) && (this.parent._downkey == true))
			{
				vpos = currVScrollTopPos + nextHeight;
			}
			else if (nextTopPos < currVScrollTopPos)
			{
				vpos = nextTopPos;
			}
			else if (currobj && (this.parent._downkey == true) && (nextobj.index == visible_end))
			{
				vpos = itemGap;
			}
	    else if ((this._prevpos != this._vscrollpos) && (preidx == rowidx))
			{
				if (this._prevpos == 0) this._prevpos = this._vscrollpos;
				vpos = this._prevpos;
			}

	    if (vpos >= 0)
			{
	        this._vscrollpos = vpos;
	        this.vscrollbar.set_pos(vpos);
			}

	    var items = this._get_contents_rows();
	    var currobj = this._getItemByRealIdx(items, this._overeditemindex).obj;
	    var nextobj = this._getItemByRealIdx(items, rowidx).obj;

	    if (currobj)
			{
	        currobj.on_apply_mouseover(false);
	        this._set_overeditemindex(-1);
			}

	    if (nextobj)
	    {
	        this._overedItem = nextobj;
	        nextobj.on_apply_mouseover(true);
	        this._set_overeditemindex(nextobj.index);
		}
	};

	_pComboListCtrl._set_overeditemindex = function (idx)
	{
	    this._overeditemindex = idx;
	    this.parent._moverindex = idx;
	};

	_pComboListCtrl._changeIndex = function (v, bIgnoreCompareIdx, change_by_script, funcname)
	{
	    var combo = this.parent;
	    
	    if (bIgnoreCompareIdx || v != this.index ||
           (combo.type == "search" && combo.index != v && v == this.index && !combo._keyval))
	    {
	        var dataset = this._innerdataset;
	        var postindex = parseInt(v, 10) | 0;

	        var preidx = this.index;
	        var pretext = this.text;
	        var prevalue = this.value;

	        var column = (this.codecolumn || this.datacolumn);
	        if (dataset && column)
	        {
	            var datavalue = dataset.getColumn(postindex, this.datacolumn || this.codecolumn);
	            var codevalue = dataset.getColumn(postindex, this.codecolumn || this.datacolumn);

	            var posttext = datavalue == undefined ? "" : datavalue;
	            var postvalue = codevalue;


	            this._prevpos = this._vscrollpos;

	            if (change_by_script != true)
	            {
	                if (this.on_fire_canitemchange(this, preidx, pretext, prevalue, postindex, posttext, postvalue) != false)
	                {
	                    this._accessibility_index = this.index = postindex;
	                    this.text = posttext;
	                    if (!this._is_value_setting)
	                    {
	                        this.value = postvalue;
	                    }
	                    this.applyto_bindSource("value", codevalue);
	                    this.on_fire_onitemchanged(this, preidx, pretext, prevalue, postindex, posttext, postvalue);
	                    return true;
	                }
	            }
	            else
	            {
	                this._accessibility_index = this.index = postindex;
	                this.text = posttext;
	                if (!this._is_value_setting)
	                {
	                    this.value = postvalue;
	                }
	                this.applyto_bindSource("value", codevalue);
	                return true;
	            }
	        }
	    }
	    else if (combo.type == "filter" && v == this.index && !combo._keyval)
	    {
	        if (funcname == "_select_add")
	            return true;

	        var dataset = combo._filtereddataset ? combo._filtereddataset : combo._getFilteredDataset();
	        v = combo._getRawIndex(dataset, v);

	        if (v != combo.index)
	        {
	            var postindex = parseInt(this.index, 10) | 0;

	            var preidx = this.index;
	            var pretext = this.text;
	            var prevalue = this.value;

	            var column = (this.codecolumn || this.datacolumn);

	            if (dataset && column)
	            {
	                var datavalue = dataset.getColumn(postindex, this.datacolumn || this.codecolumn);
	                var codevalue = dataset.getColumn(postindex, this.codecolumn || this.datacolumn);

	                var posttext = datavalue == undefined ? "" : datavalue;
	                var postvalue = codevalue;

	                if (this.on_fire_canitemchange(this, preidx, pretext, prevalue, postindex, posttext, postvalue) != false)
	                {
	                    this._accessibility_index = this.index = postindex;
	                    this.text = posttext;
	                    if (!this._is_value_setting)
	                    {
	                        this.value = postvalue;
	                    }
	                    this.applyto_bindSource("value", codevalue);

	                    this.on_fire_onitemchanged(this, preidx, pretext, prevalue, postindex, posttext, postvalue);
	                    return true;
	                }
	            }
	        }
	        else
	        {
	            var rowobj = this._get_rowobj_byrow(v);
	            if (rowobj && rowobj.selected == false)
	                rowobj.set_selected(true);

	            if (combo._isPopupVisible() && !change_by_script)
	            {
	                combo.popupwindow._closePopup();
	            }
	        }
	    }

	    return false;
	};

	delete _pComboListCtrl;
	_pComboListCtrl = null;


	// ==============================================================================
	// nexacro.ComboListItemCtrl ( Combo SubCtrol 2 )
	// ==============================================================================
	nexacro.ComboListItemCtrl = function (id, position, left, top, width, height, right, bottom, parent)
	{
		nexacro.ListItemCtrl.call(this, id, position, left, top, width, height, right, bottom, parent);
	};

	var _pComboListItemCtrl = nexacro._createPrototype(nexacro.ListItemCtrl, nexacro.ComboListItemCtrl);
	nexacro.ComboListItemCtrl.prototype = _pComboListItemCtrl;

	//---------------------------------------------------------------
	// nexacro.ComboListItemCtrl : Event Handlers
	//---------------------------------------------------------------
	_pComboListItemCtrl.on_mousemove_basic_action = function ()
	{
		var overobj = this.parent._overedItem;

		if (overobj && overobj != this)
		{
			if (overobj._apply_pushed_pseudo && overobj._is_push)
			{
				overobj._stat_change("notpush", "normal");
				overobj._is_pushed_area = false;
			}
			else if (!overobj._selected)
			{
				overobj._stat_change("", "normal");
			}
		}

		this.parent._overedItem = this;

		if (this._apply_pushed_pseudo && this._is_push)
		{
			this._stat_change("push", "pushed");
			this._is_pushed_area = true;
		}
		else
		{
			this.parent._set_overeditemindex(this.index);
			this._stat_change("", "mouseover");
		}
	};

	_pComboListItemCtrl.on_apply_mouseover = function (isovered)
	{
		if (this.selected)
		{
			return;
		}
		if (isovered)
		{
			this._stat_change("notselect", "mouseover");
		}
		else
		{
			this._stat_change("notselect", "normal");
		}
	};

	_pComboListItemCtrl.on_apply_selected = function ()
	{
		if (this.selected)
		{
			this._stat_change("select", "selected");
		}
		else
		{
			this._stat_change("notselect", "normal");
		}
	};

	_pComboListItemCtrl._common_lbuttonup = function (changedtouchinfos, elem, canvasX, canvasY, from_elem)
	{
	    if (changedtouchinfos)
	    {
	        var touchinfo = nexacro._getFirstTouchInfo(changedtouchinfos);

	        if (touchinfo)
	        {
	            elem = touchinfo._elem;
	            canvasX = touchinfo.canvasX;
	            canvasY = touchinfo.canvasY;
	            from_elem = elem;
	        }
	    }

	    if (elem != from_elem)
	    {
	        this.parent.parent._is_real_upelem = from_elem;
	    }

	    return true;
	};

	_pComboListItemCtrl._on_touchend = function (touch_manager, touchinfos, changedtouchinfos, event_bubbles, fire_comp, refer_comp)
	{
	    this._common_lbuttonup(changedtouchinfos, null, null, null, null);
	    return nexacro.Component.prototype._on_touchend.call(this, touch_manager, touchinfos, changedtouchinfos, event_bubbles, fire_comp, refer_comp);
	};

	_pComboListItemCtrl._on_lbuttonup = function (elem, button, alt_key, ctrl_key, shift_key, canvasX, canvasY, screenX, screenY, event_bubbles, fire_comp, refer_comp, from_elem)
	{
	    this._common_lbuttonup(null, elem, canvasX, canvasY, from_elem);
	    return nexacro.Component.prototype._on_lbuttonup.call(this, elem, button, alt_key, ctrl_key, shift_key, canvasX, canvasY, screenX, screenY, event_bubbles, fire_comp, refer_comp, from_elem);
	};

	delete _pComboListItemCtrl;
	_pComboListItemCtrl = null;


	// ==============================================================================
	// nexacro.ComboEditCtrl ( Combo SubCtrol 3 )
	// ==============================================================================
	nexacro.ComboEditCtrl = function (id, position, left, top, width, height, right, bottom, parent)
	{
		nexacro.EditCtrl.call(this, id, position, left, top, width, height, right, bottom, parent);
		this._accessibility_role = "combobox";
	};

	var _pComboEditCtrl = nexacro._createPrototype(nexacro.EditCtrl, nexacro.ComboEditCtrl);
	nexacro.ComboEditCtrl.prototype = _pComboEditCtrl;

	//---------------------------------------------------------------
	// nexacro.ComboEditCtrl : Style
	//---------------------------------------------------------------
	_pComboEditCtrl.on_find_CurrentStyle_color = function (pseudo)
	{
	    return this.parent.on_find_CurrentStyle_color(pseudo, this) || nexacro.Component._default_color;
	};

	_pComboEditCtrl.on_find_CurrentStyle_font = function (pseudo)
	{
	    return this.parent.on_find_CurrentStyle_font(pseudo, this) || nexacro.Component._default_font;
	};

	_pComboEditCtrl.on_find_CurrentStyle_align = function (pseudo)
	{	    
	    return this.parent.on_find_CurrentStyle_align(pseudo, this) || nexacro.Component._default_align;
	};

	_pComboEditCtrl.on_find_CurrentStyle_accessibility = function (pseudo)
	{	    
	    return this.parent.on_find_CurrentStyle_accessibility(pseudo, this) || nexacro.Component._default_accessibility;
	};

	_pComboEditCtrl.on_find_CurrentStyle_background = function (pseudo)
	{
	    return this.parent.on_find_CurrentStyle_background(pseudo, this);
	};

	_pComboEditCtrl.on_find_CurrentStyle_border = function (pseudo)
	{
	    return this.parent.on_find_CurrentStyle_border(pseudo, this);
	};

	_pComboEditCtrl.on_find_CurrentStyle_bordertype = function (pseudo)
	{
	    return this.parent.on_find_CurrentStyle_bordertype(pseudo, this);
	};

	_pComboEditCtrl.on_find_CurrentStyle_gradation = function (pseudo)
	{
	    return this.parent.on_find_CurrentStyle_gradation(pseudo, this);
	};

	//---------------------------------------------------------------
	// nexacro.ComboEditCtrl : Override
	//---------------------------------------------------------------
	_pComboEditCtrl.on_apply_custom_setfocus = function (evt_name)
	{
		var input_elem = this._input_element;
		if (input_elem)
		{
		    if (nexacro._enableaccessibility)
		    {
		        input_elem._setElementInputRole();
		    }
			input_elem.setElementFocus(true);
		}
	};

	_pComboEditCtrl.on_get_style_accessibility_label = function ()
	{
		return "";//this.value;
	};

	_pComboEditCtrl._getFromComponent = function (comp)
	{
		var parent = comp.parent;
		if (parent && parent._isPopupVisible())
			return parent;
		else
			return nexacro.Component.prototype._getFromComponent.call(this, comp);
	};

	//---------------------------------------------------------------
	// nexacro.ComboEditCtrl : Properties
	//---------------------------------------------------------------
	_pComboEditCtrl.set_value = function (v)
	{
		nexacro.Edit.prototype.set_value.call(this, v);

		this._setAccessibilityValue(this.text, true);

		if (this.parent.type == "dropdown" && this._input_element._is_focused == true)
		{
			this.setCaretPos(0);
		}
	};

	//---------------------------------------------------------------
	// nexacro.ComboEditCtrl : Event Handlers
	//---------------------------------------------------------------
	_pComboEditCtrl.on_fire_ondblclick = function (button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY, from_comp, from_refer_comp)
	{
		return this.parent.on_fire_ondblclick(button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY, from_comp, from_refer_comp);
	};

	delete _pComboEditCtrl;
	_pComboEditCtrl = null;

	// ==============================================================================
	// nexacro.ComboButtonCtrl ( Combo SubCtrol 4 )
	// ==============================================================================
	nexacro.ComboButtonCtrl = function (id, position, left, top, width, height, right, bottom, parent)
	{
		nexacro.ButtonCtrl.call(this, id, position, left, top, width, height, right, bottom, parent);
	};

	var _pComboButtonCtrl = nexacro._createPrototype(nexacro.ButtonCtrl, nexacro.ComboButtonCtrl);
	nexacro.ComboButtonCtrl.prototype = _pComboButtonCtrl;

	//---------------------------------------------------------------
	// nexacro.ComboButtonCtrl : Style
	//---------------------------------------------------------------
	_pComboButtonCtrl.on_find_CurrentStyle_background = function (pseudo)
	{
	    return this._find_ctrl_pseudo_obj("background", pseudo, "background");
	};

	_pComboButtonCtrl.on_find_CurrentStyle_gradation = function (pseudo)
	{
	    return this._find_ctrl_pseudo_obj("gradation", pseudo, "gradation");
	};

	_pComboButtonCtrl.on_find_CurrentStyle_border = function (pseudo)
	{
	    return this._find_ctrl_pseudo_obj("border", pseudo, "border");
	};

	_pComboButtonCtrl.on_find_CurrentStyle_bordertype = function (pseudo)
	{
	    return this._find_ctrl_pseudo_obj("bordertype", pseudo, "bordertype");
	};

	_pComboButtonCtrl.on_find_CurrentStyle_align = function (pseudo)
	{
	    return this._find_ctrl_pseudo_obj("align", pseudo, "align") || nexacro.Component._default_align;
	};

	_pComboButtonCtrl.on_find_CurrentStyle_margin = function (pseudo)
	{
	    return this._find_ctrl_pseudo_obj("margin", pseudo, "margin") || nexacro.Component._default_margin;
	};

	_pComboButtonCtrl.on_find_CurrentStyle_cursor = function (pseudo)
	{
	    return this._find_ctrl_pseudo_obj("cursor", pseudo, "cursor") || nexacro.Component._default_cursor;
	};

	_pComboButtonCtrl.on_find_CurrentStyle_opacity = function (pseudo)
	{
	    return this._find_ctrl_pseudo_obj("opacity", pseudo, "opacity") || nexacro.Component._default_opacity;
	};

	_pComboButtonCtrl.on_find_CurrentStyle_shadow = function (pseudo)
	{
	    return this._find_ctrl_pseudo_obj("shadow", pseudo, "shadow");
	};

	//---------------------------------------------------------------
	// nexacro.ComboButtonCtrl : Override 
	//---------------------------------------------------------------
	_pComboButtonCtrl.on_apply_custom_setfocus = function (evt_name)
	{
		var parent = this.parent;
        if (parent)
        {
            var edit = parent.comboedit;
            if (edit)
            {
                if (!(nexacro.isTouchInteraction && nexacro.SupportTouch))
                {
                    edit.on_apply_custom_setfocus(evt_name);
                }
                else
                {
                    nexacro.Component.prototype.on_apply_custom_setfocus.call(this, evt_name);
                }
            }
        }
	};

	//---------------------------------------------------------------
	// nexacro.ComboButtonCtrl : Event Handlers
	//---------------------------------------------------------------
	_pComboButtonCtrl.on_fire_onclick = function (button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY, from_comp, from_refer_comp)
	{
	    //on touch devices, application.enabletouchevent == false
	    if (nexacro.isTouchInteraction && nexacro.SupportTouch && !application.enabletouchevent)
	    {
	        var evt = new nexacro.EventInfo(this, "ondropdown");
	        this.parent.on_notify_ondropdown(this, evt);
	    }

		return this.parent.on_fire_onclick(button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY, from_comp, from_refer_comp);
	};

	_pComboButtonCtrl.on_fire_ondblclick = function (button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY, from_comp, from_refer_comp)
	{
		return this.parent.on_fire_ondblclick(button, alt_key, ctrl_key, shift_key, screenX, screenY, canvasX, canvasY, clientX, clientY, from_comp, from_refer_comp);
	};

	delete _pComboButtonCtrl;
	_pComboButtonCtrl = null;

	// ==============================================================================
	// nexacro.ComboPopupWindow ( Combo SubCtrol 5 )
	// ==============================================================================
	nexacro.ComboPopupWindow = function (id, position, left, top, width, height, right, bottom, parent)
	{
		nexacro.PopupComponent.call(this, id, position, left, top, width, height, right, bottom, parent);
		this._is_subcontrol = true;
	};

	var _pPopupWindow = nexacro._createPrototype(nexacro.PopupComponent, nexacro.ComboPopupWindow);
	nexacro.ComboPopupWindow.prototype = _pPopupWindow;

	//---------------------------------------------------------------
	// nexacro.ComboPopupWindow : Properties
	//---------------------------------------------------------------
	_pPopupWindow.set_visible = function (v)
	{
	    nexacro.PopupComponent.prototype.set_visible.call(this, v);

	    var rel_comp = this.parent;
	    if (!v)
	    {
	        var keyval = rel_comp._keyval;
	        var ei = rel_comp._eventinfo;

	        if (keyval === null || keyval === undefined)
	        {
	            if (rel_comp.displaynulltext != "" && rel_comp.value == undefined)
	            {   // Associated RP_38233) displaynulltext속성이 지정되어 있으면 comboedit.value에 text를 넣으면 안된다.
	                rel_comp._setEditValue(undefined);
	            }
	            else
	            {
	                rel_comp._setEditValue(rel_comp.text);
	            }
	        }

	        rel_comp.on_fire_oncloseup(rel_comp, ei.preindex, ei.pretext, ei.prevalue, ei.postindex, ei.posttext, ei.postvalue, ei.isselect);

	        //if (rel_comp.type == "filter")
	        //{
	        //rel_comp._filtereddataset.filter("");
	        //}
	    }
	    else
	    {
	        rel_comp._eventinfo.isselect = false;
	    }
	};

	//---------------------------------------------------------------
    // nexacro.ComboPopupWindow : Override
    //---------------------------------------------------------------
	_pPopupWindow._closePopup = function () 
	{
	    if (nexacro._enableaccessibility)
	        this.parent._want_arrows = false;
	    nexacro.PopupComponent.prototype._closePopup.call(this);
	}

	//---------------------------------------------------------------
	// nexacro.ComboPopupWindow : Logical Part
	//---------------------------------------------------------------
	_pPopupWindow._getMainFrame = function ()
	{
		var form = this;
		while (form && form instanceof nexacro.MainFrame)
		{
			form = form.parent;
		}
		return form;
	};

	_pPopupWindow._popupAuto = function (totalw, totalh)
	{
		var combo = this.parent;
		var combolist = this._attached_comp;
		if (!combolist)
			return;

		var rootframe = this._getOwnerFrame();

		if (!rootframe)
			return;

		var rootwindow = rootframe._getWindow()
		rootframe = rootwindow ? rootwindow.frame : null;
		if (!rootframe)
			return;

		var scale = this._getCumulativeZoomFactor() / 100.0;
		var p = nexacro._getElementPositionInFrame(combo.getElement());
		var s = nexacro._getElementPositionInFrame(rootframe.getElement());
		var s2 = nexacro._getElementScreenPosition(rootframe.getElement());

		var combolist_width = totalw;
		var combolist_height = totalh * scale;
		var combo_width = combo._adjust_width;
		var combo_height = combo._adjust_height * scale;
		var _left, _right, _top, _bottom, _width, _height;
		var body_width, body_height;
		var pre_height = totalh;
		var vscroll_width, text_width, max_width;

		body_width = s.x + rootframe._adjust_width;
		body_height = s.y + rootframe._adjust_height;

		var scrgap = s2.y + body_height - nexacro._getScreenAvailHeight();

		if (scrgap > 0)
		    body_height -= scrgap;

		_left = 0;
		_top = combo_height;
		_width = combolist_width;
		_height = combolist_height;

	    // combolist를 하단으로 붙여서 item 전부를 보여주기엔 화면이 좁은 상황 => combolist를 상단으로 붙인다.
		if ((p.y + combo_height + combolist_height) > body_height)
		{
            // 콤보 bottom에서 화면 아래까지 남은 공간
			var space_below = body_height - (p.y + combo_height);
			var list_pt = list_pb = list_bt = list_bb = 0;
			var list_item_h = (parseInt(combolist.currentstyle.itemheight._value, 10)) * scale;

			if (combolist.currentstyle.padding)
			{
				list_pt = (parseInt(combolist.currentstyle.padding.top, 10)) * scale;
				list_pb = (parseInt(combolist.currentstyle.padding.bottom, 10)) * scale;
			}
			if (combolist.currentstyle.border)
			{
				list_bt = (parseInt(combolist.currentstyle.border.top_width, 10)) * scale;
				list_bb = (parseInt(combolist.currentstyle.border.bottom_width, 10)) * scale;
			}
			var list_pd_bd = list_pt + list_pb + list_bt + list_bb;
			var rowcnt = combo.displayrowcount;  // Associated RP_38379)combo는 그리드의 콤보일수도 있고, 그냥 콤보일수도 있다.
			if (rowcnt == -1)
			{   // displayrowcount가 -1(default)일때는 innerdataset을 모두 보여준다.
			    rowcnt = combolist._innerdataset._viewRecords.length;
			}
			if (space_below < list_item_h * rowcnt + list_pd_bd && p.y > space_below)
			{
			    // 하단에 남은 공간이 item 3개를 표시할 공간이 안되고,
			    // 상단에 더 많은 공간이 남을 경우, 콤보의 위에 리스트 표시
				if (p.y < _height)
					_height = p.y;
				_top = -_height;
			}
			else
			{
                // 그렇지 않으면 하단 남은 공간을 전부 사용 (스크롤이 생김)
				_height = space_below;
			}
		}

		if (p.x < s.x)
		{
			var gap = s.x - p.x;
			_left += gap;
		}
		else if (p.x + combolist_width > s.x + body_width)
		{
			var gap = (p.x + combolist_width) - (s.x + body_width);
			_left -= gap;
		}

		var f = this.parent;
		while (f)
		{
		    if (f instanceof nexacro.Form)
		    {
		        break;
		    }
		    f = f.parent;
		}

		if (f && f.currentstyle && f.currentstyle.border)
		{
		    if (f.currentstyle.border._left_width == 0)
		        _left += 1;
            else
		        _left += parseInt(f.currentstyle.border._left_width / 2, 10);

		    if (f.currentstyle.border._top_width)
		        _top += parseInt(f.currentstyle.border._top_width / 2, 10);
		    else
		        _top += 1;
		}
        		
		text_width = this.parent._getMaxTextSize(this.parent._innerdataset);

		if (combolist.vscrollbar)
		{
			vscroll_width = combolist.vscrollbar.width;
			max_width = text_width + vscroll_width;

			if ((combo_width < max_width) && (_height < pre_height))
			{
				_width += vscroll_width;
			}
		}

	    var popupsize = { width: _width, height: _height / scale };

	    // 팝업도 동일 비율로 확대/축소
	    var elem = this.getElement();
	    if (elem.setZoom)
	        elem.setZoom(scale * 100);
	    else if (nexacro.ScrollableContainerElement.prototype.setZoom)
	        nexacro.ScrollableContainerElement.prototype.setZoom.call(elem, scale * 100);

		this._popupBy(this.parent, _left, _top, popupsize.width, popupsize.height);

	    // Html은 element가 zoom 되면 랜더링 영역도 같이 늘어나지만
	    // Runtime은 element 크기로 clipping되기 때문에, element크기는 늘리되, Client Element크기는 원래 크기를 유지해야 한다.
	    // 이 내용은 공통 코드로 들어가야함.
	};

	delete _pPopupWindow;

	//================================================================
	// nexacro.ComboCtrl
	//================================================================
	nexacro.ComboCtrl = function (id, absolute, left, top, width, height, right, bottom, parent)
	{
		nexacro.Combo.call(this, id, absolute, left, top, width, height, right, bottom, parent);
		this._is_subcontrol = true;
	};

	var _pComboCtrl = nexacro.ComboCtrl.prototype = nexacro._createPrototype(nexacro.Combo, nexacro.ComboCtrl);
	_pComboCtrl._type_name = "ComboControl";

	nexacro._setForControlStyleFinder(_pComboCtrl);
	delete _pComboCtrl;
}
