//==============================================================================
//
//  TOBESOFT Co., Ltd.
//  Copyright 2014 TOBESOFT Co., Ltd.
//  All Rights Reserved.
//
//  NOTICE: TOBESOFT permits you to use, modify, and distribute this file 
//          in accordance with the terms of the license agreement accompanying it.
//
//  Readme URL: http://www.nexacro.co.kr/legal/nexacro-public-license-readme-1.0.html	
//
//==============================================================================

//======================================================================================
// nexacro.ProgressBar && nexacro.ProgressBar_Style
//======================================================================================
if (!nexacro.ProgressBar)
{
    //==================================================================================
    // nexacro.ProgressBar_Style
    //==================================================================================
    nexacro.ProgressBar_Style = function (target)
    {
        nexacro.Style.call(this);
        if (target)
        {
            this._target = target;
        }
    };

    var _pProgressBarStyle = nexacro._createPrototype(nexacro.Style, nexacro.ProgressBar_Style);
    nexacro.ProgressBar_Style.prototype = _pProgressBarStyle;

    eval(nexacro._createValueAttributeEvalStr("_pProgressBarStyle", "bartype"));
    eval(nexacro._createValueAttributeEvalStr("_pProgressBarStyle", "smooth"));
    eval(nexacro._createValueAttributeEvalStr("_pProgressBarStyle", "direction"));
    eval(nexacro._createValueAttributeEvalStr("_pProgressBarStyle", "startimage"));
    eval(nexacro._createValueAttributeEvalStr("_pProgressBarStyle", "progressimage"));
    eval(nexacro._createValueAttributeEvalStr("_pProgressBarStyle", "endimage"));
    eval(nexacro._createValueAttributeEvalStr("_pProgressBarStyle", "barcolor"));
    eval(nexacro._createGradationAttributeEvalStr("_pProgressBarStyle", "bargradation"));

    _pProgressBarStyle.__custom_emptyObject = function ()
    {
        this.bartype = null;
        this.smooth = null;
        this.direction = null;
        this.startimage = null;
        this.progressimage = null;
        this.endimage = null;
        this.barcolor = null;
        this.bargradation = null;
    };

    _pProgressBarStyle.__get_custom_style_value = function ()
    {
        var val = "";
        if (this.bartype && !this.bartype._is_empty)
        {
            val += "bartype:" + this.bartype._value + "; ";
        }
        if (this.smooth && !this.smooth._is_empty)
        {
            val += "smooth:" + this.smooth._value + "; ";
        }
        if (this.direction && !this.direction._is_empty)
        {
            val += "direction:" + this.direction._value + "; ";
        }
        if (this.startimage && !this.startimage._is_empty)
        {
            val += "startimage:" + this.startimage._value + "; ";
        }
        if (this.progressimage && !this.progressimage._is_empty)
        {
            val += "progressimage:" + this.progressimage._value + "; ";
        }
        if (this.endimage && !this.endimage._is_empty)
        {
            val += "endimage:" + this.endimage._value + "; ";
        }
        if (this.barcolor && !this.barcolor._is_empty)
        {
            val += "barcolor:" + this.barcolor._value + "; ";
        }
        if (this.bargradation && !this.bargradation._is_empty)
        {
            val += "bargradation:" + this.bargradation._value + "; ";
        }
        return val;
    };

    //---------------------------------------------------------------
    nexacro.ProgressBar_CurrentStyle = function ()
    {
        nexacro.CurrentStyle.call(this);
        this.bartype = null;
        this.smooth = null;
        this.direction = null;
        this.startimage = null;
        this.progressimage = null;
        this.endimage = null;
        this.barcolor = null;
        this.bargradation = null;
    };

    var _pProgressBarCurrentStyle = nexacro._createPrototype(nexacro.CurrentStyle, nexacro.ProgressBar_CurrentStyle);
    nexacro.ProgressBar_CurrentStyle.prototype = _pProgressBarCurrentStyle;

    _pProgressBarCurrentStyle.__custom_emptyObject = _pProgressBarStyle.__custom_emptyObject;
    _pProgressBarCurrentStyle.__get_custom_style_value = _pProgressBarStyle.__get_custom_style_value;

    // end of ProgressBar Style
    _pProgressBarStyle = null;
    _pProgressBarCurrentStyle = null;

    //==================================================================================
    // nexacro.ProgressBar
    //==================================================================================
    nexacro.ProgressBar = function (id, position, left, top, width, height, right, bottom, parent)
    {
        nexacro.Component.call(this, id, position, left, top, width, height, right, bottom, parent);

        this.celllist = [];
        this.cellitem = null;

        this.start_img = null;
        this.progress_img = null;
        this.progress_img_list = new Array();
        this.end_img = null;

        this.statictext = null;
        this.style_list = null;

        this.start_img_width = 0;
        this.progress_img_width = 0;
        this.end_img_width = 0;
        this.start_img_url = "";
        this.progress_img_url = "";
        this.end_img_url = "";

        this._accessibility_role = "progressbar";
    };

    var _pProgressBar = nexacro._createPrototype(nexacro.Component, nexacro.ProgressBar);
    nexacro.ProgressBar.prototype = _pProgressBar;

    _pProgressBar._type_name = "ProgressBar";

    _pProgressBar.pos = "0";  // default value 0 <- spac why set "0"
    _pProgressBar.step = "1";
    _pProgressBar.max = "100";
    _pProgressBar.min = "0";
    _pProgressBar.blocksize = "15";
    _pProgressBar.blockgap = "2";

    //==================================================================================
    // nexacro.ProgressBar : Style Part
    //==================================================================================
    nexacro.ProgressBar._default_bartype = nexacro._getCachedStyleObj("bartype", "normal");

    _pProgressBar.on_apply_custom_pseudo = function (pseudo)
    {
        if (!pseudo)
        {
            pseudo = this._pseudo;
        }
        var curstyle = this.currentstyle;
        var bartype = this.on_find_CurrentStyle_bartype(pseudo);
        var smooth = this.on_find_CurrentStyle_smooth(pseudo);
        var direction = this.on_find_CurrentStyle_direction(pseudo);
        var startimage = this.on_find_CurrentStyle_startImage(pseudo);
        var progressimage = this.on_find_CurrentStyle_progressImage(pseudo);
        var endimage = this.on_find_CurrentStyle_endImage(pseudo);
        var barcolor = this.on_find_CurrentStyle_barColor(pseudo);
        var bargradation = this.on_find_CurrentStyle_barGradation(pseudo);
        var font = this.on_find_CurrentStyle_font(pseudo);
        var color = this.on_find_CurrentStyle_color(pseudo);
        var align = this.on_find_CurrentStyle_align(pseudo);

        if (curstyle.font != font)
        {
            curstyle.font = font;
            this.on_apply_style_font(font);
        }

        if (curstyle.color != color)
        {
            curstyle.color = color;
            this.on_apply_style_color(color);
        }

        if (curstyle.align != align)
        {
            curstyle.align = align;
            this.on_apply_style_align(align);
        }

        if (bartype != curstyle.bartype)
        {
            curstyle.bartype = bartype;
            this.on_apply_style_bartype(bartype);
        }

        if (smooth != curstyle.smooth)
        {
            curstyle.smooth = smooth;
            this.on_apply_style_smooth(smooth);
        }

        if (direction != curstyle.direction)
        {
            curstyle.direction = direction;
            this.on_apply_style_direction(direction);
        }

        if (startimage != curstyle.startimage)
        {
            curstyle.startimage = startimage;
            this.on_apply_style_startimage(startimage);
        }

        if (progressimage != curstyle.progressimage)
        {
            curstyle.progressimage = progressimage;
            this.on_apply_style_progressimage(progressimage);
        }
        if (endimage != curstyle.endimage)
        {
            curstyle.endimage = endimage;
            this.on_apply_style_endimage(endimage);
        }
        if (barcolor != curstyle.barcolor)
        {
            curstyle.barcolor = barcolor;
            this.on_apply_style_barcolor(barcolor);
        }
        if (bargradation != curstyle.bargradation)
        {
            curstyle.bargradation = bargradation;
            this.on_apply_style_bargradation(bargradation);
        }
        //this.on_apply_text();
        //this._update(true);		
    };

    _pProgressBar.on_create_custom_style = function ()
    {
        return new nexacro.ProgressBar_Style(this);
    };

    _pProgressBar.on_create_custom_currentStyle = function ()
    {
        return new nexacro.ProgressBar_CurrentStyle();
    };


    /* find style */
    _pProgressBar.on_find_CurrentStyle_bartype = function (pseudo)
    {
        var bartype = this._find_pseudo_obj("bartype", pseudo);
        return (bartype) ? bartype : nexacro.ProgressBar._default_bartype;
    };
    _pProgressBar.on_find_CurrentStyle_smooth = function (pseudo)
    {
        return this._find_pseudo_obj("smooth", pseudo);
    };
    _pProgressBar.on_find_CurrentStyle_direction = function (pseudo)
    {
        return this._find_pseudo_obj("direction", pseudo);
    };
    _pProgressBar.on_find_CurrentStyle_startImage = function (pseudo)
    {
        return this._find_pseudo_obj("startimage", pseudo);
    };
    _pProgressBar.on_find_CurrentStyle_progressImage = function (pseudo)
    {
        return this._find_pseudo_obj("progressimage", pseudo);
    };
    _pProgressBar.on_find_CurrentStyle_endImage = function (pseudo)
    {
        return this._find_pseudo_obj("endimage", pseudo);
    };
    _pProgressBar.on_find_CurrentStyle_barColor = function (pseudo)
    {
        return this._find_pseudo_obj("barcolor", pseudo, "color");
    };
    _pProgressBar.on_find_CurrentStyle_barGradation = function (pseudo)
    {
        return this._find_pseudo_obj("bargradation", pseudo, "gradation");
    };

    /* update style */
    _pProgressBar.on_update_style_bartype = function ()
    {
        var bartype = this.currentstyle.bartype = this.on_find_CurrentStyle_bartype(this._pseudo);
        this.on_apply_style_bartype(bartype);
    };
    _pProgressBar.on_update_style_smooth = function ()
    {
        var smooth = this.currentstyle.smooth = this.on_find_CurrentStyle_smooth(this._pseudo);
        this.on_apply_style_smooth(smooth);
    };
    _pProgressBar.on_update_style_direction = function ()
    {
        var direction = this.currentstyle.direction = this.on_find_CurrentStyle_direction(this._pseudo);
        this.on_apply_style_direction(direction);
    };
    _pProgressBar.on_update_style_startimage = function ()
    {
        var startimage = this.currentstyle.startimage = this.on_find_CurrentStyle_startImage(this._pseudo);
        this.on_apply_style_startimage(startimage);
    };
    _pProgressBar.on_update_style_progressimage = function ()
    {
        var progressimage = this.currentstyle.progressimage = this.on_find_CurrentStyle_progressImage(this._pseudo);
        this.on_apply_style_progressimage(progressimage);
    };
    _pProgressBar.on_update_style_endimage = function ()
    {
        var endimage = this.currentstyle.endimage = this.on_find_CurrentStyle_endImage(this._pseudo);
        this.on_apply_style_endimage(endimage);
    };
    _pProgressBar.on_update_style_barcolor = function ()
    {
        var barcolor = this.currentstyle.barcolor = this.on_find_CurrentStyle_barColor(this._pseudo);
        this.on_apply_style_barcolor(barcolor);
    };
    _pProgressBar.on_update_style_bargradation = function ()
    {
        var bargradation = this.currentstyle.bargradation = this.on_find_CurrentStyle_barGradation(this._pseudo);
        this.on_apply_style_bargradation(bargradation);
    };

    /* apply style */
    _pProgressBar.on_apply_style_bartype = function (bartype)
    {
        this._update();
    };

    _pProgressBar.on_apply_style_smooth = function (smooth)
    {
        if (smooth == undefined)
        {
            smooth = this.on_find_CurrentStyle_smooth(this._pseudo);
        }

        if (smooth == true && this.celllist && this.celllist.length > 1)
        {
            for (i = 1; i < this.celllist.length; i++)
            {
                this.celllist[i].destroy();
            }
        }
        this._update();
    };

    _pProgressBar.on_apply_style_direction = function (direction)
    {
        this._update();
    };


    // *** img apply *** //
    _pProgressBar.on_apply_style_startimage = function (startimage)
    {
        startimage = this.currentstyle.startimage; 
        if (startimage == null)
        {
            return;
        }

        startimage = this._get_img_fullurl(startimage);
        var size = nexacro._getImageSize(startimage, this._on_start_img, this);
        if (size != null)
        {
            this._on_start_img(startimage, size.width, size.height);
        }
    };

    _pProgressBar.on_apply_style_progressimage = function (progressimage)
    {
        if (progressimage == null)
        {
            return;
        }
        progressimage = this._get_img_fullurl(progressimage);

        var size = nexacro._getImageSize(progressimage, this._on_progress_img, this);
        if (size != null)
        {
            this._on_progress_img(progressimage, size.width, size.height);
        }
    };

    _pProgressBar.on_apply_style_endimage = function (endimage)
    {
        if (endimage == null)
        {
            return;
        }
        endimage = this._get_img_fullurl(endimage);

        var size = nexacro._getImageSize(endimage, this._on_end_img, this);
        if (size != null)
        {
            this._on_end_img(endimage, size.width, size.height);
        }
    };

    _pProgressBar.on_apply_style_barcolor = function (barcolor)
    {
        var cell_item = this.cellitem;
        if (!cell_item)
        {
            return;
        }

        if (barcolor == null)
        {
            barcolor = "transparent";
        }
        else
        {
            barcolor = barcolor.toString();
        }

        if (barcolor != "@gradation")
        {
            cell_item.style.set_background(barcolor);

            // block 형 
            // cell이 복수 개일때 (smooth = false)
            var cell_list = this.celllist;
            if (cell_list)
            {
                var cLen = cell_list.length;
                for (i = 1 ; i < cLen; i++)
                {
                    cell_list[i].style.set_background(barcolor);
                }
            }
        }
    };

    _pProgressBar.on_apply_style_bargradation = function (bargradation)
    {
        var cell_item = this.cellitem;
        if (!cell_item)
        {
            return;
        }

        if (bargradation == null)
        {
            return;
        }

        var barcolor = this.currentstyle.barcolor; 
        if (barcolor == null)
        {
            barcolor = "transparent";
        }
        else
        {
            barcolor = barcolor.toString();
        }

        var i;
        if (barcolor == "@gradation")
        {
            cell_item.style.set_background(barcolor);
            cell_item.on_update_style_gradation();
            // block 형 
            // cell이 복수 개일때 (smooth = false)

            var cell_list = this.celllist;
            if (cell_list)
            {
                var cLen = cell_list.length;
                for (i = 1 ; i < cLen; i++)
                {
                    cell_list[i].style.set_background(barcolor);
                    cell_list[i].on_update_style_gradation();
                }
            }
        }
    };

    _pProgressBar.on_apply_style_color = function (color)
    {
        if (this._text_elem)
        {
            this._text_elem.setElementColor(color);
        }
    };

    _pProgressBar.on_apply_style_font = function (font)
    {
        if (this._text_elem)
        {
            this._text_elem.setElementFont(font);
            this._text_width = -1;
            this._text_height = -1;
        }
    };

    _pProgressBar.on_apply_style_align = function (align)
    {
        if (this._text_elem && align)
        {
            var halign = align.halign == "" ? "center" : align._halign;
            var valign = align.valign == "" ? "middle" : align._valign;
            this._text_elem.setElementAlignXY(halign, valign);
        }
    };

    //==================================================================================
    // nexacro.ProgressBar : Create & Destroy & Update
    //==================================================================================
    _pProgressBar.on_create_contents = function ()
    {
        var control_elem = this.getElement();
        if (control_elem)
        {
            if (this.text)
            {
                var text_elem = this._text_elem = new nexacro.TextBoxElement(control_elem);
                var halign = this.currentstyle.align.halign == "" ? "center" : this.currentstyle.align._halign;
                var valign = this.currentstyle.align.valign == "" ? "middle" : this.currentstyle.align._valign;
                text_elem.setElementSize(this._client_width, this._client_height);
                text_elem.setElementColor(this.currentstyle.color);
                text_elem.setElementFont(this.currentstyle.font);
                text_elem.setElementAlignXY(halign, valign);
            }

            var curBartype = this.on_find_CurrentStyle_bartype(this._pseudo);
            if (curBartype != "image")
            {
                this.cellitem = new nexacro.ProgressBarCell("cell0", "absolute", 0, 0, 0, this._client_height, null, null, this);
                this.cellitem.createComponent();
            }
        }
    };

    _pProgressBar.on_created_contents = function ()
    {

        this.on_apply_style_startimage(this.currentstyle.startimage);
        this.on_apply_style_endimage(this.currentstyle.endimage);
        this.on_apply_style_progressimage(this.currentstyle.progressimage);
        this.on_apply_style_direction(this.currentstyle.direction);
        this.on_apply_style_align(this.currentstyle.align);
        this.on_apply_style_smooth(this.currentstyle.smooth);
        this.on_apply_style_bartype(this.currentstyle.bartype);
        this.on_apply_style_barcolor(this.currentstyle.barcolor);
        this.on_apply_style_bargradation(this.currentstyle.bargradation);

        if (nexacro._enableaccessibility && this._isAccessibilityEnable())
        {
            this._setAccessibilityInfoValueMin(this.min);
            this._setAccessibilityInfoValueMax(this.max);
            this._setAccessibilityInfoValueCur(this.pos);
        }

        var text_elem = this._text_elem;
        var img_elem = this._img_elem;
        var cell_item = this.cellitem;

        if (cell_item)
        {
            cell_item.on_created();
        }
        if (img_elem)
        {
            img_elem.create();
        }
        if (text_elem)
        {
            text_elem.create();
        }
       
        this.on_apply_text(this.text);
    }

    _pProgressBar.on_destroy_contents = function ()
    {
        if (this._text_elem)
        {
            this._text_elem.destroy();
            this._text_elem = null;
        }

        if (this._img_elem)
        {
            this._img_elem.destroy();
            this._img_elem = null;
        }

        this._delete_cell();

        this.progress_img_list = null;
        this.start_img = null;
        this.progress_img = null;
        this.end_img = null;
        this.statictext = null;
        this.style_list = null;
    };

    _pProgressBar.on_change_containerRect = function (width, height)
    {
        var textElem = this._text_elem;
        if (textElem)
        {
            textElem.setElementSize(width, height);
        }
        this._update();
    }

    //============================================================
    // nexacro.ProgressBar : override
    //============================================================   
    _pProgressBar._on_getAccessibilityAdditionalLabel = function ()
    {
        var additional = "";
        if (this._isAccessibilityEnable())
        {
            var expr = this.expr;
            if (expr && expr.length > 0)
            {
                additional = this.displaytext;
            }
            else
            {
                additional = this.pos;
            }

            additional = additional + " " + this.min + " " + this.max;
        }
        return additional;
    };

    _pProgressBar._on_getAccessibilityAdditionalRole = function ()
    {
    	if (this._getAccessibilityRole(this.on_find_CurrentStyle_accessibility(this._pseudo)) == "progressbar")
    		return " ProgressBar";
    	return "";
    };
    //============================================================
    // nexacro.ProgressBar : Properties
    //============================================================
    _pProgressBar.on_apply_text = function ()
    {
        var control_elem = this._control_element;
        if (control_elem)
        {
            var text_elem = this._text_elem;
            if (!text_elem)
            {
                text_elem = new nexacro.TextBoxElement(control_elem);
                this._text_elem = text_elem;
                text_elem.setElementSize(this._client_width, this._client_height);
                var halign = this.currentstyle.align.halign == "" ? "center" : this.currentstyle.align._halign;
                var valign = this.currentstyle.align.valign == "" ? "middle" : this.currentstyle.align._valign;

                text_elem.setElementColor(this.currentstyle.color);
                text_elem.setElementFont(this.currentstyle.font);
                text_elem.setElementAlignXY(halign, valign);
    
                text_elem.create();

            }

            var expr = this.expr;

            if (expr && expr.length > 0)
            {
                // 1. expr - Uppercase and lowercase lgnore
                // 2. Ignore blank 
                // 3. work without "epxr:" 

                // Separated by ":" -> expr string exists and other case are separated
                expr = expr.trim().split(":");
                var len = expr.length;
                var parser = new nexacro.ExprParser();
                var conv_expr, exprfn;
                var str;

                if (len == 1)    // When there is not "|"
                {
                    str = expr[0];
                }
                else   // When there is "|"
                {
                    if (expr[0].trim().toUpperCase() != "EXPR")   // expr string exists this.expr = "param1?"true":"false";
                    {
                        str = expr.join(":");
                    }
                    else // expr string not exist -->  first Array delete and add up
                    {
                        str = expr.slice(1).join(":");
                    }
                }

                conv_expr = parser.makeExpr(this, str);
                exprfn = nexacro._createInlineFunc(conv_expr, ["comp", "pos"]);

                if (exprfn)
                {
                    try
                    {
                        var val = nexacro._toString(exprfn.call(null, this, this.pos));
                        if (val != this.displaytext)
                        {
                            this.displaytext = val;
                            if (nexacro._enableaccessibility && this._isAccessibilityEnable())
                            {
                                this._setAccessibilityValue(val);
                                this._notifyAccessibility(val, "notify");
                            }
                        }
                    }
                    catch (e)   // error ignore
                    {
                        return;
                    }
                }
            }
            else
            {
                this.displaytext = this.text;
            }
            
            text_elem.setElementText(this.displaytext);
            this.on_apply_style_align(this.currentstyle.align);
        }
    };

    _pProgressBar.on_apply_expr = function ()
    {
        this.on_apply_text();
    };

    _pProgressBar.set_blockgap = function (v)
    {
        if (this.blockgap != v)
        {
            var blockgap = parseInt(v) | 0;
            if (blockgap < 0)
            {
                blockgap = 0;
            }
            this.blockgap = blockgap;

            this._update();
        }
    };

    _pProgressBar.set_blocksize = function (v)
    {
        if (this.blocksize != v)
        {
            var blocksize = parseInt(v) | 0;
            if (blocksize < 1)
            {
                blocksize = 1;
            }
            this.blocksize = blocksize;
            this._update();
        }
    };

    _pProgressBar.set_min = function (v)
    {
        if (this.min != v)
        {
            var min = parseInt(v) | 0;
            var max = parseInt(this.max) | 0;
            var pos = parseInt(this.pos) | 0;
            if (min < 0)
            {
                min = 0;
            }
            if (min > max)
            {
                this.max = min;
            }
            if (min > pos)
            {
                this.pos = min;
            }
            this.min = min;
            if (nexacro._enableaccessibility && this._isAccessibilityEnable())
            {
                this._setAccessibilityInfoValueMin(min);
            }
            this._update();
        }
    };

    _pProgressBar.set_max = function (v)
    {
        if (this.max != v)
        {
            var max = parseInt(v) | 0;
            var min = parseInt(this.min) | 0;
            var pos = parseInt(this.pos) | 0;
            if (max < 0)
            {
                max = 0;
            }
            if (max < min)
            {
                this.min = max;
            }
            if (max < pos)
            {
                this.pos = max;
            }
            this.max = max;
            if (nexacro._enableaccessibility && this._isAccessibilityEnable())
            {
                this._setAccessibilityInfoValueMax(max);
            }
            this._update();
        }
    };

    _pProgressBar.set_pos = function (v)
    {
        v = parseInt(v) | 0;

        if (this.pos != v)
        {
            var pos = v;
            var min = parseInt(this.min) | 0;
            var max = parseInt(this.max) | 0;
            if (pos < 0)
            {
                pos = 0;
            }
            if (pos > max)
            {
                pos = max;
            }
            else if (pos < min)
            {
                pos = min;
            }
            this.pos = pos;
            if (nexacro._enableaccessibility && this._isAccessibilityEnable())
            {
                this._setAccessibilityInfoValueCur(pos);
            }
            this._update();
        }
    };

    _pProgressBar.set_step = function (v)
    {
        if (this.step != v)
        {
            this.step = v;
            this._update();
        }
    };

    //============================================================
    // nexacro.GroupBox : Methods
    //============================================================

    _pProgressBar.resize = function (w, h)
    {
        nexacro.Component.prototype.resize.call(this, w, h);   // CompBase call
        this._update();
    };

    _pProgressBar.move = function (left, top, width, height, right, bottom)
    {
        nexacro.Component.prototype.move.call(this, left, top, width, height, right, bottom);   // CompBase call
        this._update();
    };

    _pProgressBar.stepIt = function ()
    {
        var pos = (parseInt(this.pos) | 0) + (parseInt(this.step) | 0);
        if (parseInt(this.max) < pos)
        {
            this.pos = this.max;
            return;
        }
        else if (parseInt(this.min) > pos)
        {
            this.pos = this.min;
            return;
        }
        else
        {
            this.pos = pos;
        }
        this._update();
    };

    //============================================================
    // nexacro.GroupBox : Event
    //============================================================

    //============================================================
    // nexacro.GroupBox : Logical Part
    //============================================================
    _pProgressBar._update = function ()
    {
        var curBartype = this.currentstyle.bartype; 
        if (!curBartype)
        {
            curBartype = nexacro.ProgressBar._default_bartype;
        }
        if (curBartype == "normal")
        {
            this._update_cell();
        }
        else
        {
            this._update_img();
        }
    };

    _pProgressBar._update_cell = function ()
    {
        this._delete_cell();

        // delete image
        this._delete_img(this.start_img);
        this._delete_img(this.end_img);
        if (this.progress_img_list)
        {
            var imgLen = this.progress_img_list.length;
            for (var i = 0; i < imgLen; i++)
            {
                this.progress_img = this.progress_img_list[i];
                this._delete_img(this.progress_img);
            }

            this.progress_img_list.splice(0, imgLen);
        }


        var height = this._client_height;
        var width = this._client_width;
        if (this.cellitem == null)
        {
            this.cellitem = new nexacro.ProgressBarCell("cell_0", "absolute", 0, 0, 0, height, null, null, this);
            this.cellitem.createComponent();
        }

        var cellitem = this.cellitem;
        var cell_list = this.celllist;
        var l, t, w, h;
        var block_size = 1;
        var pos = parseInt(this.pos) | 0;
        var max = parseInt(this.max) | 0;
        var min = parseInt(this.min) | 0;
        var per = (pos - min) / (max - min);
        var smooth = this.currentstyle.smooth;     //this.on_find_CurrentStyle_smooth(this._pseudo);
        var direction = this.currentstyle.direction;  //this.on_find_CurrentStyle_direction(this._pseudo);
        var blocksize = parseInt(this.blocksize) | 0;
        var blockgap = parseInt(this.blockgap) | 0;

        if (smooth == "true")
        {
            if (direction == "backward")
            {
                t = cellitem._adjust_top;
                w = parseInt(width * per) | 0;
                l = width - parseInt(width * per) | 0;
                h = height;
            }
            else
            {
                l = 0; //cellitem._adjust_left ;  // forward일 경우 left, top은 무조건 0
                t = 0; //cellitem._adjust_top ;
                w = parseInt(width * per) | 0;
                h = height;
            }
            cellitem._applysetPosition(l, t, w, h);

            cellitem.show();
        }
        else
        {  // block 처리일 때
            if (direction == "backward") 
            {
                w = blocksize;
                l = width - blocksize;
                t = cellitem._adjust_top;
                h = cellitem._adjust_height;

                cellitem._applysetPosition(l, t, w, h);

                cell_list[0] = cellitem;

                block_size = blockgap + blocksize;

                var size = Math.ceil((width / block_size) * per);
                for (var i = size; i > 0; i--)
                {
                    l = width - (i * block_size);
                    t = 0;

                    w = blocksize;
                    h = height;
                    cell_list[i] = new nexacro.ProgressBarCell("cell_" + i, "absolute", l, t, w, h, null, null, this);
                    cell_list[i].createComponent();
			   
                }
                this.celllist = cell_list;
            }
            else
            {
                l = cellitem._adjust_left;
                t = cellitem._adjust_top;

                h = cellitem._adjust_height;
                w = blocksize;
                cellitem._applysetPosition(l, t, w, h);

                cell_list[0] = cellitem;

                block_size = blockgap + blocksize;

                var size = Math.ceil((width / block_size) * per);
                for (var i = 1; i < size; i++)
                {
                    l = (i * block_size);
                    t = 0;

                    w = blocksize;
                    h = height;
                    cell_list[i] = new nexacro.ProgressBarCell("cell_" + i, "absolute", l, t, w, h, null, null, this);
                    cell_list[i].createComponent();
		   
                }
                this.celllist = cell_list;
            }
        }

        // apply text and style
        var textElem = this._text_elem;
        if (textElem)
        {
            textElem.destroy();
            this._text_elem = null;
        }

        var control_elem = this.getElement();
        if (control_elem)
        {
            textElem = this._text_elem = new nexacro.TextBoxElement(control_elem);
          
            var halign = cellitem.currentstyle.align.halign == "" ? "center" : cellitem.currentstyle.align._halign;
            var valign = cellitem.currentstyle.align.valign == "" ? "middle" : cellitem.currentstyle.align._valign;

            textElem.setElementSize(this._client_width, this._client_height);
            textElem.setElementColor(this.currentstyle.color);
            textElem.setElementFont(this.currentstyle.font);
            textElem.setElementAlignXY(halign, valign);

            if (textElem)
            {
                textElem.create();
            }

            this.on_apply_style_align(this.currentstyle.align);
            this.on_apply_style_barcolor(this.currentstyle.barcolor);
            this.on_apply_style_bargradation(this.currentstyle.bargradation);

            this.on_apply_text(this.text);
        }


        return cellitem;
    };

    _pProgressBar._delete_cell = function ()
    {

        if (this.celllist)
        {
            var len = this.celllist.length;
            for (i = 0; i < len; i++)
            {
                this.celllist[i].destroy();
                delete this.celllist[i];
            }
            this.celllist.splice(0, len);
        }


        if (this.cellitem)
        {
            this.cellitem.destroy();
            this.cellitem = null;
        }

    };

    //--------------------------------------------------------
    // *** img 로드 & 생성 *** //		
    _pProgressBar._on_start_img = function (imgurl, w, h)
    {
        this.start_img_width = w;
        this.start_img_url = imgurl;
        this._update_img();

    };

    _pProgressBar._on_progress_img = function (imgurl, w, h)
    {
        this.progress_img_width = w;
        this.progress_img_url = imgurl;
        this._update_img();
    };

    _pProgressBar._on_end_img = function (imgurl, w, h)
    {
        this.end_img_width = w;
        this.end_img_url = imgurl;
        this._update_img();
    };

    // *** img 생성 & bg.img 적용 ***// 
    _pProgressBar._create_img = function (img, img_val, id)
    {
        if (img_val != null && img_val != "")
        {
            img = new nexacro.ProgressBarImg(id, "absolute", 0, 0, 0, this._client_height, null, null, this);
            img.createComponent();

            if (id == "startimage")
                img_val = this.currentstyle.startimage;
            else if (id == "endimage")
                img_val = this.currentstyle.endimage;
            else
                img_val = this.currentstyle.progressimage;

            img.style.set_background("transparent URL('" + img_val + "') stretch");     // img_val이 fullpath로 넘어가면 안됨.
            return img;
        }
    }

    _pProgressBar._delete_img = function (img)
    {
        if (img == null)
        {
            return;
        }
        img.destroy();
    }

    // img url 변환
    _pProgressBar._get_img_fullurl = function (img)
    {
        img = nexacro._toString(img);
        if (img.substring(0, 4).toLowerCase() == "url(")
        {
            img = img.substring(5, img.length - 2);
        }
        
        img = nexacro._getImageLocation(img, this._getRefFormBaseUrl());
        return img;
    };

    // 각 img - set - position
    //_pProgressBar.img_cnt = 0;
    _pProgressBar._update_img = function ()
    {
        var curbartype = this.currentstyle.bartype; 
        if (curbartype == "normal" || !this.progress_img_url)
        {
            return;
        }
        this._delete_cell();
        var direction = this.currentstyle.direction; 
        if (curbartype == "image")
        {
            if (direction == "backward")
            {
                var progress_w = this.progress_img_width;
                var start_w = 0;
                var end_w = 0;
                var height = this._client_height;
                var width = this._client_width;
                var pos = parseInt(this.pos) | 0;
                var max = parseInt(this.max) | 0;
                var min = parseInt(this.min) | 0;
                var posX = ((pos - min) / (max - min)) * width;
                posX = parseInt(posX) | 0;
                var cnt = 0;
                var l = 0;
                var t = 0;
                var r = 0;
                var b = height;

                this._delete_img(this.start_img);
                this.start_img = this._create_img(this.start_img, this.start_img_url, "startimage");
                if (this.start_img)
                {
                    start_w = this.start_img_width;
                }

                this._delete_img(this.end_img);
                this.end_img = this._create_img(this.end_img, this.end_img_url, "endimage")
                if (this.end_img)
                {
                    end_w = this.end_img_width;
                }

                cnt = parseInt((posX - start_w - end_w) / progress_w) | 0;

                if (this.progress_img_list)
                {
                    var imgLen = this.progress_img_list.length;
                    for (var i = 0; i < imgLen; i++)
                    {
                        this.progress_img = this.progress_img_list[i];
                        this._delete_img(this.progress_img);
                    }
                    this.progress_img_list = [];
                }

                if (this.end_img && this.progress_img)
                {
                    l = width - end_w;
                    this.end_img._applysetPosition(l, t, end_w, b);
                }

                var progress_img = null;
                var pImg_start = l - progress_w;

                for (var i = 0; i < cnt; i++)
                {
                    progress_img = this._create_img(this.progress_img, this.progress_img_url, "pImg" + i);

                    l = pImg_start - (progress_w * i);
                    t = 0;
                    progress_img._applysetPosition(l, t, progress_w, b);
                    this.progress_img_list[i] = progress_img;
                }

                if (this.start_img)
                {
                    l = l - start_w;
                    this.start_img._applysetPosition(l, t, start_w, b);
                }
            }
            else
            {
                var progress_w = this.progress_img_width;
                var start_w = 0;
                var end_w = 0;
                var height = this._client_height;
                var width = this._client_width;
                var pos = parseInt(this.pos) | 0;
                var max = parseInt(this.max) | 0;
                var min = parseInt(this.min) | 0;
                var posX = ((pos - min) / (max - min)) * width;
                posX = parseInt(posX) | 0;
                var cnt = 0;
                var l = 0;
                var t = 0;
                var r = 0;
                var b = height;

                this._delete_img(this.start_img);
                this.start_img = this._create_img(this.start_img, this.start_img_url, "startimage");
                if (this.start_img)
                {
                    start_w = this.start_img_width;
                }

                this._delete_img(this.end_img);
                this.end_img = this._create_img(this.end_img, this.end_img_url, "endimage")
                if (this.end_img)
                {
                    end_w = this.end_img_width;
                }

                cnt = parseInt((posX - start_w - end_w) / progress_w) | 0;

                if (this.progress_img_list)
                {
                    for (var i = 0; i < this.progress_img_list.length; i++)
                    {
                        this.progress_img = this.progress_img_list[i];
                        this._delete_img(this.progress_img);
                    }
                    this.progress_img_list = [];
                }

                for (var i = 0; i < cnt; i++)
                {
                    this.progress_img = this._create_img(this.progress_img, this.progress_img_url, "pImg" + i);
                    this.progress_img_list[i] = this.progress_img;
                }


                if (this.start_img)
                {
                    r = start_w;
                    this.start_img._applysetPosition(l, t, r - l, b - t);
                }

                for (var i = 0; i < cnt; i++)
                {
                    if (i > 0)
                    {
                        var img_item = this.progress_img_list[i - 1];
                        l = img_item._adjust_left + img_item._adjust_width;
                        t = 0;
                       
                        r = l + progress_w;
                        b = height;
                    }
                    else
                    {
                        if (this.start_img)
                        {
                            l = this.start_img._adjust_left + this.start_img._adjust_width;
                            r = l + progress_w;
                        }
                        else
                        {
                            l = 0;
                            r = progress_w;
                        }
                    }
                    this.progress_img_list[i]._applysetPosition(l, t, r - l, b - t);
                    this.progress_img = this.progress_img_list[i];
                }

                if (this.end_img && this.progress_img)
                {
                    l = this.progress_img._adjust_left + this.progress_img._adjust_width;
                    r = l + end_w;
                    this.end_img._applysetPosition(l, t, r - l, b - t);
                }
            }

            // apply text and style
            var textElem = this._text_elem;
            if (textElem)
            {
                textElem.destroy();
                this._text_elem = null;
            }

            var control_elem = this.getElement();
            if (control_elem)
            {
                text_elem = this._text_elem = new nexacro.TextBoxElement(control_elem);
                var halign = this.currentstyle.align.halign == "" ? "center" : this.currentstyle.align._halign;
                var valign = this.currentstyle.align.valign == "" ? "middle" : this.currentstyle.align._valign;
                text_elem.setElementSize(this._client_width, this._client_height);
                text_elem.setElementColor(this.currentstyle.color);
                text_elem.setElementFont(this.currentstyle.font);
                text_elem.setElementAlignXY(halign, valign);

                if (text_elem)
                {
                    text_elem.create();
                }

                this.on_apply_text(this.text);
            }

        }
    };

    _pProgressBar = null;

    //==================================================================================
    // ProgressBarCell : Static
    // description :  ProgressBar' bar subComp
    //==================================================================================
    nexacro.ProgressBarCell = function (id, position, left, top, width, height, right, bottom, parent)
    {
        nexacro.StaticCtrl.call(this, id, position, left, top, width, height, right, bottom, parent);        
        this._is_reference_control = false;
    };
    _pProgressBarCell = nexacro.ProgressBarCell.prototype = nexacro._createPrototype(nexacro.StaticCtrl, nexacro.ProgressBarCell);

    _pProgressBarCell.on_find_CurrentStyle_gradation = function (pseudo)
    {
        return this.parent._find_pseudo_obj("bargradation", pseudo, "gradation");
    };

    _pProgressBarCell.on_find_CurrentStyle_padding = function (pseudo)       // parent 와의 간격 조절
    {
        return null;
    };
    _pProgressBarCell.on_apply_style_color = function (color)
    {
        return null;
    };
    _pProgressBarCell.on_apply_style_font = function (font)
    {
        return null;
    };
    _pProgressBarCell.on_apply_style_align = function (align)
    {
        return null;
    };

    _pProgressBarCell.on_apply_text = function ()
    {
        return null;
    };
    _pProgressBarCell.on_apply_expr = function ()
    {
        return null;
    };
    _pProgressBarCell.on_apply_wordwrap = function ()
    {
        return null;
    };


    delete _pProgressBarCell;

    //==================================================================================
    // ProgressBarImg : - Static
    // description :  ProgressBar' ImgBar subComp
    //==================================================================================
    nexacro.ProgressBarImg = function (id, position, left, top, width, height, right, bottom, parent)
    {
        nexacro.StaticCtrl.call(this, id, position, left, top, width, height, right, bottom, parent);
        
        this._is_reference_control = false;
    };
    _pProgressBarImg = nexacro.ProgressBarImg.prototype = nexacro._createPrototype(nexacro.StaticCtrl, nexacro.ProgressBarImg);

    //------ Static에서 쓰이는 prep 중 불필요한 기능 제거----------//
    _pProgressBarImg.on_find_CurrentStyle_border = function (pseudo)         // cell 로 사용시 border가 있는 경우가 있음
    {
        return null;
    };
    _pProgressBarImg.on_find_CurrentStyle_padding = function (pseudo)        // parent 와의 간격 조절
    {
        return null;
    };
    _pProgressBarImg.on_apply_style_color = function (color)
    {
        return null;
    };
    _pProgressBarImg.on_apply_style_font = function (font)
    {
        return null;
    };
    _pProgressBarImg.on_apply_style_align = function (align)
    {
        return null;
    };

    _pProgressBarImg.on_apply_text = function ()
    {
        return null;
    };
    _pProgressBarImg.on_apply_expr = function ()
    {
        return null;
    };
    _pProgressBarImg.on_apply_wordwrap = function ()
    {
        return null;
    };

    delete _pProgressBarImg;

    //==========================================================================================================
    // ProgressBarCtrl : SubControl
    // description :  ProgressBar used as Control ==> use Event Notifiers, style control - controlType
    //==========================================================================================================
    nexacro.ProgressBarCtrl = function (id, position, left, top, width, height, right, bottom, parent)
    {
        nexacro.ProgressBar.call(this, id, position, left, top, width, height, right, bottom, parent);
        this._is_subcontrol = true;
    };

    var _pProgressBarCtrl = nexacro.ProgressBarCtrl.prototype = nexacro._createPrototype(nexacro.ProgressBar, nexacro.ProgressBarCtrl);
    _pProgressBarCtrl._type_name = "ProgressBarControl";

    _pProgressBarCtrl._is_focus_accept = false;

    nexacro._setForControlStyleFinder(_pProgressBarCtrl);

    delete _pProgressBarCtrl;

}

