﻿//==============================================================================
//
//  TOBESOFT Co., Ltd.
//  Copyright 2014 TOBESOFT Co., Ltd.
//  All Rights Reserved.
//
//  NOTICE: TOBESOFT permits you to use, modify, and distribute this file 
//          in accordance with the terms of the license agreement accompanying it.
//
//  Readme URL: http://www.nexacro.co.kr/legal/nexacro-public-license-readme-1.0.html	
//
//==============================================================================
if (this.nexacro)
{
    nexacro._errortable =
    {
        "ko":
        {
            "reference_not_define": ["%0", "가 정의되지 않았습니다. "],
            "reference_fail_findcolumn": ["Dataset에서 지정한 Column[", "%0", "] 을 찾지 못했습니다."],
            "syntax_fail_parse_xml": ["파싱 중 에러가 발생되었습니다.[", "%0", "]"],
            "syntax_not_set_samepath": ["form과 같은 경로로 설정할수 없습니다.[", "%0", "]"],
            "type_invalid": ["추가할수 없는 타입입니다.[", "%0", "]"],
            "type_mismatch": ["입력 파라미터의 데이터 형식이 일치하지 않습니다. [", "%0", "]"],

            "range_argument": ["Argument가 맞지 않습니다.[", "%0", ".", "%1", "]"],
            "range_outof": ["입력 파라미터가 유효 범위를 벗어났습니다. [", "%0", "]"],
            "range_invalide": ["입력 파라미터가 유효한 값이 아닙니다. [", "%0", "]"],

            "native_notimplemented": ["구현되지 않은 기능입니다. [", "%0", "]"],
            "native_notsupport": ["HTML5에서 지원되지 않는 객체 또는 속성입니다.", "%0", "[", "%1", "]"],
            "native_deprecate": ["해당 기능은 Deprecate 된 기능입니다. [", "%0", "]"],

            "native_fail_dataset_head": ["데이타셋의 헤더정보를 로딩하는 중 실패하였습니다."],
            "native_fail_dataset_recode": ["데이타셋의 레코드 정보를 로딩하는 중 실패하였습니다."],
            "native_exist_id": ["해당 ID를 갖는 Object 가 존재합니다. id = [", "%0", "]"],
            "native_exist_parent": ["parent가 이미 존재합니다. "],
            "native_notexist_parent": ["parent 가 존재하지 않습니다."],
            "native_notexist_licensefile": ["라이센스 화일이 존재하지 않습니다. "],
            "native_expire_license": ["라이센스 기간이 [", "%0", "]로 만료되었습니다.    "],
            "native_invalid_licensefile": ["라이센스 정보가 유효하지 않습니다. 라이센스를 확인하시기 바랍니다."],
            "native_license_invaliddomain": ["라이센스 도메인 정보가 정확하지 않습니다. 도메인 확인이 필요합니다.  [", "%0", "]"],
            "native_license_fail_parse": ["라이센스 도메인 정보가 정확하지 않습니다. 라이센스 화일을 분석하는 도중 에러가 발생하였습니다.  [", "%0", "]"],
            "native_fail_openfile": ["파일을 열지 못했습니다. [", "%0", "]"],
            "native_license_invalidservice": ["해당 서비스를 지원하지 않는 라이센스입니다. 라이센스를 확인하시기 바랍니다. "],

            "comm_fail_loadinvalidurl": ["로딩하는 중에 에러가 발생하였습니다. 주소가 정확한지 확인하고 다시 시도하십시오. [", "%0", "]"],
            "comm_fail_loadinvalidimage": ["이미지 정보를 찾을 수 없습니다.[", "%0", "]"],
            "comm_fail_translate_url": ["경로를 변경하는데 오류가 발생하였습니다.[", "%0", "]"],
            "comm_fail_loaddetail": ["로딩하는 중에 에러가 발생하였습니다. 주소가 정확한지 확인하고 다시 시도하십시오. 경로 [", "%0", "] HTTP 에러코드 [", "%1", "]"],
            "comm_cancel_byuser": ["사용자에 의해 통신이 중지 되었습니다. [", "%0", "]"],
            "comm_stop_transaction_byesc": ["Transaction이 Esc Key에 의해 중단됩니다.  ( 표준이 아닙니다. )"],
            "comm_http_400": ["클라이언트의 잘못된 요청으로 처리할 수 없습니다.\n 주소가 정확한지 확인하고 다시 시도하십시오.  "],
            "comm_http_404": ["요청한 경로에서 문서를 찾을 수 없습니다.\n 주소가 정확한지 확인하고 다시 시도하십시오. "],
            "comm_http_405": ["사이트에서 페이지를 표시할 수 없습니다.  "],
            "comm_http_500": ["내부서버 오류입니다.   "],
            "comm_http_503": ["외부 서비스가 죽었거나 현재 멈춤 상태 입니다.  "],
            "comm_http_499": ["요청 오류입니다.    "],
            "comm_http_599": ["서버 에러입니다.   "],
            "comm_http_401": ["서버에 로그온 하려는 요청사항이 서버에 들어있는 권한과 맞지 않습니다.    "],
            "comm_http_402": ["예약되어 있습니다.   "],
            "comm_http_403": ["브라우저가 접근한 디렉토리에 가용한 디폴트 페이지가 없습니다.   "],
            "comm_http_406": ["받아들일 수 없는 요청입니다.  "],
            "comm_http_407": ["Proxy 인증이 필요합니다.   "],
            "comm_http_408": ["요청시간이 지났습니다. "],
            "comm_http_301": ["요청한 URI가 새 URI로 변경되었습니다."],
            "comm_http_302": ["요청한 URI가 일시적으로 변경되었습니다."],
            "comm_http_305": ["요청한 자원은 반드시 Proxy Location을 사용하여 접근해야 합니다."],
            "comm_http_307": ["요청한 URI가 일시적으로 변경되었습니다."],

            "script_error": ["스크립트 오류입니다.[", "%[0]", "] "],

            "msg_access_invalid_file": ["안전하지 않은 파일에 접근합니다.\n계속 진행하시겠습니까?\n\n[", "%0", "]"],
            "msg_access_invalid_domain": ["안전하지 않은 도메인에 접근합니다.\n계속 진행하시겠습니까?\n\n[", "%0", "]"],
            "msg_permit_folder": ["이 폴더 및 하위 폴더는 항상 허용"],
            "msg_permit_domain": ["이 도메인은 항상 허용"],

            "msg_update_processing": ["실행중인 Process[", "%0", "] 가 있어서 Update가 실패하였습니다. 실행중인 Process를 자동 종료하려면 Yes(예), 실행중인 Process를 직접 종료하고 난 후에 계속 진행하려면 No(아니오), Restart 후에 Update를 적용하려면 Cancel(무시)를 선택합니다. "],
            "msg_reset_sandboxdialog": ["프로그램 개선에 따라 폴더/도메인 접근 경고창에서 기존에 설정 하였던 허용 여부를 재설정 하여야만 합니다. 고객님의 많은 양해 부탁드립니다."],

            "msg_start": ["nexacro platform 을 시작합니다."],
            "msg_search_proxyserver": ["프록시 서버 설정 검색중."],
            "msg_update_engine": ["엔진 파트를 업데이트 합니다."],
            "msg_download": ["ADL 컨텐츠를 다운로딩 합니다."],

            "comp_incorrect_file": ["지정된 화일이 올바르지 않습니다.  "],
            "comp_fail_loadactivex": ["ActiveX / Applet 수행시 에러가 발생하였습니다. [", "%0", "]"]
        },
        "en":
        {
            "reference_not_define": ["%0", "is undefined identifier."],
            "reference_fail_findcolumn": ["Cannot found the specified column [", "%0", "] in Dataset."],
            "syntax_fail_parse_xml": ["error has occurred while parsing [", "%0", "]"],
            "syntax_not_set_samepath": ["Cannot set same path with form.[", "%0", "]"],
            "type_invalid": ["Type mismatch.[", "%0", "]"],
            "type_mismatch": ["The input parameter type is mismatch. [", "%0", "]"],

            "range_argument": ["The input parameter is incorrect.[", "%0", ".", "%1", "]"],
            "range_outof": ["The input parameter value is out of range [", "%0", "]"],
            "range_invalide": ["The input parameter value is wrong. [", "%0", "]"],

            "native_notimplemented": ["not implemented. [", "%0", "]"],
            "native_notsupport": ["The [", "%0", "[ object or property does not support in HTML5. [", "%1", "]"],
            "native_deprecate": ["Deprecated with . [", "%0", "]"],

            "native_fail_dataset_head": ["An error has occurred while loading Dataset header information."],
            "native_fail_dataset_recode": ["An error has occurred while loading record information."],
            "native_exist_id": ["Object with the ID [", "%0", "] already exists."],
            "native_exist_parent": ["parent already exists."],
            "native_notexist_parent": ["parent not exist."],
            "native_notexist_licensefile": ["not exist license file of application."],
            "native_expire_license": ["License period is expired for [", "%0", "]."],
            "native_invalid_licensefile": ["invalid license format."],
            "native_license_invaliddomain": ["invalid license domain.  [", "%0", "]"],
            "native_license_fail_parse": ["An error has occurred while analyzing License file."],
            "native_fail_openfile": ["fail open file. [", "%0", "]"],
            "native_license_invalidservice": ["check license. "],

            "comm_fail_loadinvalidurl": ["fail to invalid url. check url. [", "%0", "]"],
            "comm_fail_loadinvalidimage": ["Image Info [", "%0", "] is not found."],
            "comm_fail_translate_url": ["URL Translation Failed .[", "%0", "]"],
            "comm_fail_loaddetail": ["[", "%0", "] loading has been failed due to following http or socket error code [", "%1", "] "],
            "comm_cancel_byuser": ["canceled communication by user. [", "%0", "]"],
            "comm_stop_transaction_byesc": ["stop Transaction by esc key. ( no standard ) "],
            "comm_http_400": ["Unintelligible Request.  "],
            "comm_http_404": ["failed to find the file in appropriate path. "],
            "comm_http_405": ["Server does not support requested method.  "],
            "comm_http_500": ["Internal Server Error.  "],
            "comm_http_503": ["Service unavailable.  "],
            "comm_http_499": ["Request Error.    "],
            "comm_http_599": ["Server Error.   "],
            "comm_http_401": ["Unauthorized.    "],
            "comm_http_402": ["Payment Required.  "],
            "comm_http_403": ["Forbidden.   "],
            "comm_http_406": ["Not Acceptable.  "],
            "comm_http_407": ["Proxy authentication required  "],
            "comm_http_408": ["Request timeout. "],
            "comm_http_301": ["Moved Permanently."],
            "comm_http_302": ["The requested resource resides temporarily under a different URI."],
            "comm_http_305": ["The requested resource MUST be accessed through the proxy given by the Location field."],
            "comm_http_307": ["The requested resource resides temporarily under a different URI."],

            "script_error": ["script error.[", "%[0]", "] "],

            "msg_access_invalid_file": ["Access to unsafe file. \n Do you want to proceed?\n\n[", "%0", "]"],
            "msg_access_invalid_domain": ["Access to unsafe domain. \n Do you want to proceed?\n\n[", "%0", "]"],
            "msg_permit_folder": ["Always allow this folder and its subfolders."],
            "msg_permit_domain": ["Always allow this domain."],
            "msg_update_processing": ["Update has failed as there is a Process [", "%0", "] in execution. Select 'Yes' to quit the Process automatically, 'Retry' to quit the Process manually and preceed, or 'Cancel' to apply the Update after Restart. "],
            "msg_reset_sandboxdialog": ["Improve the program based on the folder / domain in Approach Warning windows were previously set should satisfy themselves whether to allow the reset. Thank you for your patience."],

            "msg_start": ["Starting nexacro platform"],
            "msg_search_proxyserver": ["Searching Proxy Server Settings."],
            "msg_update_engine": ["Updating Engine Parts."],
            "msg_download": ["Downloading ADL Contents."],

            "comp_incorrect_file": ["The file is not correct. "],
            "comp_fail_loadactivex": ["Failed to execute ActiveX / Applet  [", "%0", "]"]
        },
        "ja":
        {
            "reference_not_define": ["%0", "が定義されていません。"],
            "reference_fail_findcolumn": ["Datasetで指定したColumn[", "%0", "]が見つかりません。"],
            "syntax_fail_parse_xml": ["パーシング中にエラーが発生しました。[", "%0", "]"],
            "syntax_not_set_samepath": ["formと同じパスでは設定できません。[", "%0", "]"],
            "type_invalid": ["追加できないタイプです。[", "%0", "]"],
            "type_mismatch": ["入力パラメ?タのデータタイプが一致しません。[", "%0", "]"],

            "range_argument": ["引数に誤りがあります。[", "%0", ".", "%1", "]"],
            "range_outof": ["入力パラメータが有効範囲を超えています。 [", "%0", "]"],
            "range_invalide": ["入力パラメータが不正です。 [", "%0", "]"],

            "native_notimplemented": ["サポートされていない機能です。[", "%0", "]"],
            "native_notsupport": ["HTML5でサポートされていないオブジェクトまたは属性です。", "%0", "[", "%1", "]"],
            "native_deprecate": ["該当の機能はDeprecateされた機能です。[", "%0", "]"],

            "native_fail_dataset_head": ["データセットのヘッダ情報をローディングに失敗しました。"],
            "native_fail_dataset_recode": ["デ?タセットのレコード情報をローディングに失敗しました。"],
            "native_exist_id": ["該当のidを持つオブジェクトが存在します。id = [", "%0", "]"],
            "native_exist_parent": ["parentがすでに存在します。"],
            "native_notexist_parent": ["parentが存在しません。"],
            "native_notexist_licensefile": ["ライセンスファイルが存在しません。"],
            "native_expire_license": ["ライセンスの有効期間が[", "%0", "]で切れました。    "],
            "native_invalid_licensefile": ["ライセンス情報が無?です。ライセンスを確認してください。"],
            "native_license_invaliddomain": ["ライセンスのドメイン情報が無効です。ドメインを確認してください。　[", "%0", "]"],
            "native_license_fail_parse": ["ライセンスのドメイン情報が無効です。ライセンスファイルの分析中にエラーが発生しました。[", "%0", "]"],
            "native_fail_openfile": ["ファイルオープンに失敗しました。[", "%0", "]"],
            "native_license_invalidservice": ["該当のサービスをサポ?トしていないライセンスです。ライセンスを確認してください。"],

            "comm_fail_loadinvalidurl": ["ローディング中にエラ?が?生しました。パスを確認してください。 [", "%0", "]"],
            "comm_fail_loadinvalidimage": ["イメージ情報が見つかりません。[", "%0", "]"],
            "comm_fail_translate_url": ["パスの変更中にエラーが?生しました。[", "%0", "]"],
            "comm_fail_loaddetail": ["ローディング中にエラーが発生しました。パスを確認してください。パス [", "%0", "] HTTP エラーコード [", "%1", "]"],
            "comm_cancel_byuser": ["ユーザーにより通信がキャンセルされました。[", "%0", "]"],
            "comm_stop_transaction_byesc": ["TransactionがEsc Keyにより中止されます。( 標準はありません )"],
            "comm_http_400": ["Unintelligible Request.  "],
            "comm_http_404": ["failed to find the file in appropriate path. "],
            "comm_http_405": ["Server does not support requested method.  "],
            "comm_http_500": ["Internal Server Error.  "],
            "comm_http_503": ["Service unavailable.  "],
            "comm_http_499": ["Request Error.    "],
            "comm_http_599": ["Server Error.   "],
            "comm_http_401": ["Unauthorized.    "],
            "comm_http_402": ["Payment Required.  "],
            "comm_http_403": ["Forbidden.   "],
            "comm_http_406": ["Not Acceptable.  "],
            "comm_http_407": ["Proxy authentication required  "],
            "comm_http_408": ["Request timeout. "],
            "comm_http_301": ["Moved Permanently."],
            "comm_http_302": ["The requested resource resides temporarily under a different URI."],
            "comm_http_305": ["The requested resource MUST be accessed through the proxy given by the Location field."],
            "comm_http_307": ["The requested resource resides temporarily under a different URI."],

            "script_error": ["スクリプトエラーです。[", "%[0]", "] "],

            "msg_access_invalid_file": ["安全ではないファイルにアクセスします。\n開けますか？\n\n[", "%0", "]"],
            "msg_access_invalid_domain": ["安全ではないドメインにアクセスします。\n開けますか？\n\n[", "%0", "]"],
            "msg_permit_folder": ["このフォルダ及び配下のフォルダは常に許容"],
            "msg_permit_domain": ["このドメインは常に許容"],
            "msg_update_processing": ["実行中のProcess[", "%0", "]があるため、Updateに失敗しました。実行中のProcessを自動終了する場合はYes(はい)、実行中のProcessを直接終了させてから続ける場合はNo(いいえ), Restart後にUpdateを適用する場合はCancel(取消)を選択します。"],
            "msg_reset_sandboxdialog": ["プログラム改善によりフォルダやドメインへのアクセス警告ウィンドウで設定したアクセス可否の設定値を再設定する必要があります。\nご了承ください。"],

            "msg_start": ["nexacro platformをスタートします。"],
            "msg_search_proxyserver": ["プロキシサーバー設定を検索中。"],
            "msg_update_engine": ["エンジンをアップデートします。"],
            "msg_download": ["ADLコンテンツをダウンロードします。"],

            "comp_incorrect_file": ["指定されたファイルが不正です。"],
            "comp_fail_loadactivex": ["ActiveX/Appletの実行時にエラーが発生しました。[", "%0", "]"]
        }
    }
}
